#include "dessin.h"

////////////////
// Fonctions: //
////////////////

void DessinePave(double x1,double y1,double z1,double x2,double y2,double z2,int LT,int HT,GLuint Text)
{
	glBindTexture(GL_TEXTURE_2D,Text);

	glBegin(GL_QUADS);

	glTexCoord2i(0,0);  glVertex3d(x1,y1,z1);
	glTexCoord2i(0,HT); glVertex3d(x1,y2,z1);
	glTexCoord2i(LT,HT);glVertex3d(x2,y2,z1);
	glTexCoord2i(LT,0); glVertex3d(x2,y1,z1);
	//1 face 
	
	glTexCoord2i(0,0);  glVertex3d(x1,y1,z2);
	glTexCoord2i(0,HT); glVertex3d(x1,y2,z2);
	glTexCoord2i(LT,HT);glVertex3d(x2,y2,z2);
	glTexCoord2i(LT,0); glVertex3d(x2,y1,z2);
	 //2 faces 
	
	glTexCoord2i(0,0);  glVertex3d(x1,y1,z2);
	glTexCoord2i(0,HT); glVertex3d(x1,y2,z2);
	glTexCoord2i(LT,HT);glVertex3d(x1,y2,z1);
	glTexCoord2i(LT,0); glVertex3d(x1,y1,z1);
	//3 faces 
	
	glTexCoord2i(0,0);  glVertex3d(x2,y1,z2);
	glTexCoord2i(0,HT); glVertex3d(x2,y2,z2);
	glTexCoord2i(LT,HT);glVertex3d(x2,y2,z1);
	glTexCoord2i(LT,0); glVertex3d(x2,y1,z1);
	 //4 faces 
	
	glTexCoord2i(0,0);  glVertex3d(x2,y1,z1);
	glTexCoord2i(LT,0); glVertex3d(x2,y1,z2);
	glTexCoord2i(LT,HT);glVertex3d(x1,y1,z2);
	glTexCoord2i(0,HT); glVertex3d(x1,y1,z1);
	//5 faces
	
	glTexCoord2i(0,0);  glVertex3d(x2,y2,z1);
	glTexCoord2i(LT,0); glVertex3d(x2,y2,z2);
	glTexCoord2i(LT,HT);glVertex3d(x1,y2,z2);
	glTexCoord2i(0,HT); glVertex3d(x1,y2,z1);

	glEnd();
}

void DessinerPerso(double PosX,double PosY,double Angle,double AngleV,int Couleur,GLuint *TextureJoueur, bool Tout)
{
	glPushMatrix();
	glTranslated( PosX, PosY,0); 
	glRotated(Angle,0,0,1);
	// noir=0,rouge=1,bleu=2,vert=3,jaune=4,orange=5,violet=6,turquoise=7 
	switch (Couleur)
	{
	case NOIR:
		glColor3d(0.3,0.3,0.3); break;
	case ROUGE:
		glColor3d(1,0.3,0.3); break;
	case BLEU:
		glColor3d(0.3,0.3,1); break;
	case VERT:
		glColor3d(1,1,1); break;
	case JAUNE:
		glColor3d(1,1,0.1); break;
	case ORANGE:
		glColor3d(1,0.7,0.3); break;
	case VIOLET:
		glColor3d(0.7,0.3,0.7); break;
	case TURQUOISE:
		glColor3d(0.3,1,1); break;
	}

	if (Tout)
	{
		DessinePave(-0.12*UNITE*JOUEUR_TAILLE	,-0.12*UNITE*JOUEUR_TAILLE	,(0+JOUEUR_HAUTEUR)*UNITE*JOUEUR_TAILLE		,0.12*UNITE*JOUEUR_TAILLE	,0.12*UNITE*JOUEUR_TAILLE	,(0.1+JOUEUR_HAUTEUR)*UNITE*JOUEUR_TAILLE	,1,1,TextureJoueur[1]); //dessin
		DessinePave(-0.07*UNITE*JOUEUR_TAILLE	,-0.07*UNITE*JOUEUR_TAILLE	,(0.1+JOUEUR_HAUTEUR)*UNITE*JOUEUR_TAILLE	,0.07*UNITE*JOUEUR_TAILLE	,0.07*UNITE*JOUEUR_TAILLE	,(0.5+JOUEUR_HAUTEUR)*UNITE*JOUEUR_TAILLE	,1,1,TextureJoueur[0]);
	}	

	if (Tout)
	{
		glTranslated(0,0,(0.3+JOUEUR_HAUTEUR)*UNITE*JOUEUR_TAILLE);
		glRotated(-AngleV,0,1,0);
		DessinePave(-0.05*UNITE*JOUEUR_TAILLE		, 0.03*UNITE*JOUEUR_TAILLE	, -0.02	,0.12*UNITE*JOUEUR_TAILLE	, 0.10*UNITE*JOUEUR_TAILLE, (0.1)*UNITE*JOUEUR_TAILLE	,1,1,TextureJoueur[1]);
		DessinePave(-0.05*UNITE*JOUEUR_TAILLE		,-0.03*UNITE*JOUEUR_TAILLE	, -0.02	,0.12*UNITE*JOUEUR_TAILLE	,-0.10*UNITE*JOUEUR_TAILLE, (0.1)*UNITE*JOUEUR_TAILLE	,1,1,TextureJoueur[1]);
	
	}
	else
	{
		glTranslated(0,0,(0.3+JOUEUR_HAUTEUR+0.07)*UNITE*JOUEUR_TAILLE);
		glRotated(-AngleV,0,1,0);
		DessinePave(-0.05*UNITE*JOUEUR_TAILLE		, 0.05*UNITE*JOUEUR_TAILLE	, -0.013	,0.1*UNITE*JOUEUR_TAILLE	, 0.10*UNITE*JOUEUR_TAILLE, (0.05)*UNITE*JOUEUR_TAILLE	,1,1,TextureJoueur[1]);
		DessinePave(-0.05*UNITE*JOUEUR_TAILLE		,-0.05*UNITE*JOUEUR_TAILLE	, -0.013	,0.1*UNITE*JOUEUR_TAILLE	,-0.10*UNITE*JOUEUR_TAILLE, (0.05)*UNITE*JOUEUR_TAILLE	,1,1,TextureJoueur[1]);
	}
	glColor3d(1,1,1);
	glPopMatrix();
}



