#ifndef __EKAUQM_FENETRE__
#define __EKAUQM_FENETRE__

#include "includes.h"
#include "constantes.h"
#include "perso.h"
#include "temps.h"
#include "map.h"
#include "math.h"
#include "reseau.h"
#include "dessin.h"
#include "texte.h"
#include "tir.h"
#include "option.h"
#include "son.h"
#include "position.h"

////////////////////////////////
// Definitions de constantes: //
////////////////////////////////

#define FENETRE_NOM						"Trembler de peur 4 - Multijoueur"

#define PERSO_HAUTEUR					1.3*UNITE
#define PERSO_VITESSE					3*UNITE/1000 // en mu/ms=u/s Vnormale=3u/s
#define PERSO_SOURIS_INV_SENSIBILITE	500 
#define PERSO_SEUIL_A					10
#define PERSO_SEUIL_V					PERSO_VITESSE*0.1

#define CONSTANTE_VISIBILITE			2

#define SOURIS_POSX						400
#define SOURIS_POSY						300

#define TEXTURE_PISTOLET				"donnees\\arme\\pistolet.gif"
#define TEXTURE_RETICULE				"donnees\\arme\\reticule.gif"

#define VITESSE_MAL						0.001

#define MORT_ATTENTE	3000

#define SEUIL_EXPULSION	20

///////////////////////////////
// Definitions de fonctions: //
///////////////////////////////

DWORD WINAPI FenetreMain(LPVOID lpParam);

/////////////////////////////
// Definitions de classes: //
/////////////////////////////

// la classe de la fenetre
class fenetre 
{
private:
	int InitialisationFaite;
	int Fps;
	int BlockageSouris;
	bool Dire;
	int NumMap;
	int TpsTir;
	int MortAttente;
	int Expulsion[CLIENT_MAX];

	char NomMap[LISTE_NOM_TAILLE_MAX];

	POINT PositionSouris;
	POINT DeplacementSouris;

	GLuint TextureJoueur[JOUEUR_TEXTURE_NB];
	GLuint TextureTexte;
	GLuint TextureArme;
	
	temps VitesseAnimation;
	temps TempsAttente;

	tir Tir;
	map Map;
	console Console;
	options Options;
	reseau *Reseau;
	son Son;
	gestionposition Positions;

public:

	perso PersoPrincipal;
	perso PersoAutre[CLIENT_MAX+1]; // +1 pour que les client puisse entrer le serveur sans tout dcaler
	
	int InitialisationFenetre(	options Opts,
								char* NomDeLaMap, 
								int NumeroMap,
								reseau* Res);
	void MessageNouveauJoueur(int ID,int Score,char *Pseudo,int Couleur,int NDest);
	bool Evenement();
	void CopierPosition(int NPerso,double X,double Y,double Angle,double AngleV,bool* Touches);
	void CalculDeplacementSouris();
	void GestionTemps();
	void Deplacement();
	void Dessin();
	void DessinPerso();
	void DessinVie();
	void DessinArme();
	void DessinMal();
	void GestionReseau();
	void InitialisationPerso();
	void ReglageCamera();
};

// les parametre  passer au thread
struct parametres
{
	int NumeroMap;
	options Opts;
	char* NomDeLaMap;
	reseau *Reseau;
};

#endif




