#include "fenetre.h"

////////////////
// Variables: //
////////////////

bool Expulse;

////////////////
// Fonctions: //
////////////////

// Fonction principale de la fentre
DWORD WINAPI FenetreMain(LPVOID lpParam)
{
	bool Continuer = true;
	bool DestinationDeterminee=false;
	fenetre Fenetre;
	parametres *Parametres=(parametres*)lpParam;	
	options Options=Parametres->Opts;

	if (Fenetre.InitialisationFenetre(Options, Parametres->NomDeLaMap, Parametres->NumeroMap, Parametres->Reseau)==ERREUR_ERREUR)
	{
		printf("\nErreur lors de l'initialisation de la fenetre\n\n>>>");
		Continuer=false;
	}
	else
		printf("\n\tPas d'erreur durant l'initialisation de la fenetre\n\n>>>");

	Fenetre.InitialisationPerso();

    while (Continuer)
    {
		Fenetre.GestionTemps();
		Continuer=Fenetre.Evenement();
		Fenetre.Deplacement();
		Fenetre.Dessin();
		Fenetre.GestionReseau();
	}	

    SDL_Quit();

	return 0;
}



// Initialisation de notre fentre
int fenetre::InitialisationFenetre(options Opts,
								   char* NomDeLaMap,
								   int NumeroMap,
								   reseau *Res)

{
	int i;

	this->NumMap=NumeroMap;
	this->Options=Opts;

	SDL_Surface *ecran;
	
	GLfloat brouillard[4] = {(float)0.7, (float)0.7, (float)0.7, (float)1.0}; 

	Reseau=Res;

	Fps=Options.FpsMax;
	BlockageSouris=1;

	VitesseAnimation.Reinitialise();
	TempsAttente.Reinitialise();

	// On initialise SDL
	printf("\nInitialisation de SDL\n");
	if (SDL_Init(SDL_INIT_VIDEO)!=0)
		return ERREUR_ERREUR;

	// On met un joli titre
	printf("Changement du titre de la fenetre\n");
    SDL_WM_SetCaption(FENETRE_NOM,NULL);

	// On initialise opengl
	printf("Initialisation d'opengl\n");
    ecran=SDL_SetVideoMode(Options.LargeurFenetre, Options.HauteurFenetre, 32, SDL_OPENGL);
	if (ecran==NULL)
		return ERREUR_ERREUR;

	// On active des truc:
	glEnable(GL_DEPTH_TEST); // zbuffer
    glEnable(GL_TEXTURE_2D); // texture

	// brouillard
	if (Options.Brouillard)
	{
		glFogi(GL_FOG_MODE, GL_LINEAR);	
		glFogf(GL_FOG_START, (float)0.1*UNITE);
		glFogf(GL_FOG_END, (float)Options.Visibilite*UNITE);      
		glFogfv(GL_FOG_COLOR, brouillard);
		glEnable(GL_FOG);  
	}

	// reglage de la transparance  
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	//glBlendFunc(GL_SRC_ALPHA, GL_ONE);             
    glAlphaFunc(GL_GREATER,0.2f); 
	glClearColor((float)brouillard[0],(float)brouillard[1],(float)brouillard[2],(float)brouillard[3]); // On met du blanc en couleur de fond

	// Reglage de la perspective:
	glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluPerspective(70,(double)Options.LargeurFenetre/Options.HauteurFenetre,UNITE/100,Options.Visibilite*CONSTANTE_VISIBILITE*UNITE);		

	// Chargement des texture du joueur
	printf("Chargement des texture des joueurs...\n");
	printf("%s\n",JOUEUR_TEXTURE_J1);
	TextureJoueur[0]=loadTexture(JOUEUR_TEXTURE_J1,1);
	if (TextureJoueur[0]==0)
	{
		printf("Erreur: Impossible de charger la texture %s\n",JOUEUR_TEXTURE_J1);
		return ERREUR_ERREUR;
	}

	printf("%s\n",JOUEUR_TEXTURE_J2);
	TextureJoueur[1]=loadTexture(JOUEUR_TEXTURE_J2,1);
	if (TextureJoueur[1]==0)
	{
		printf("Erreur: Impossible de charger la texture %s\n",JOUEUR_TEXTURE_J2);
		return ERREUR_ERREUR;
	}

	// Chargement des texture de l'arme
	printf("Chargement des texture de l'arme...\n");
	printf("%s\n",TEXTURE_RETICULE);
	TextureArme=loadTexture(TEXTURE_RETICULE,1);
	if (TextureArme==0)
	{
		printf("Erreur: Impossible de charger la texture %s\n",TEXTURE_RETICULE);
		return ERREUR_ERREUR;
	}

	// Initialisation de la police pour l'affichage du texte:
	printf("Initialisation du texte...\n");
	printf("%s\n",TEXTE_NOM_TEXTURE);
	TextureTexte=loadTexture(TEXTE_NOM_TEXTURE,0);

	if (TextureTexte==0)
	{
		printf("Erreur: Impossible de charger la texture %s\n",TEXTE_NOM_TEXTURE);
		printf("Initialisation du texte impossible\n");
		return ERREUR_ERREUR;
	}
	else
	{
		Console.Initialise();
		InitialiseTexte(TextureTexte);
	}
	Dire=0;

	// On charge la map:
	this->NumMap=NumeroMap;
	strcpy(NomMap,NomDeLaMap);
	printf("Chargement de la map...\n");
	Map.InitialisationMap();
	if (Reseau->Serveur)
	{
		if (Map.ChargeMap(NomDeLaMap, 1, NumeroMap)!=ERREUR_AUCUNE)
		{
			printf("Erreur lors du chargement de la map");
			return ERREUR_ERREUR;
		}
	}
	
	// On initialise les balles:
	Tir.Initialisation();
	TpsTir=0;

	// On met la variable expuse  0:
	Expulse=0;

	// Initialisation des sons
	printf("Initialisation des sons\n");
	Son.Initialisation();
	Son.AjouterSon(SON_TIR_NOM);	
	Son.AjouterSon(SON_TOUCHE_NOM);
	Son.AjouterSon(SON_MAL_NOM);
	Son.AjouterSon(SON_TELEPORTEUR_NOM);
	Son.AjouterSon(SON_PORTE_OUVRE_NOM);
	Son.AjouterSon(SON_PORTE_FERME_NOM);
	Son.AjouterSon(SON_CAISSE_NOM);

	// Initialisation des position:
	Positions.Initialisation();

	// Diver:
	MortAttente=MORT_ATTENTE+100;
	for (i=0;i<CLIENT_MAX;i++)
		Expulsion[i]=0;

	// Activation de la repetition des touche:
	SDL_EnableKeyRepeat(500,50);

	return ERREUR_AUCUNE;
}

bool fenetre::Evenement()
{	
	if (Expulse)
	{
		printf("L'hote vous a expulse de la partie\n");
		return false;
	}

	unsigned int x=Options.LargeurFenetre;
	unsigned int y=Options.HauteurFenetre;
	SDL_Event event;
    while (SDL_PollEvent(&event))
	{
		switch(event.type)
		{
			case SDL_QUIT:
				return false;

			case SDL_MOUSEBUTTONDOWN:
				switch (event.button.button)
				{
				case SDL_BUTTON_LEFT:
					if (TpsTir<0)
					{
						double PosBalle[MESSAGE_PARAMETRE_MAX];
						PosBalle[0]=PersoPrincipal.X;
						PosBalle[1]=PersoPrincipal.Y;
						PosBalle[2]=PERSO_HAUTEUR*0.9;
						PosBalle[3]=cos(PersoPrincipal.Angle*PI/180)*UNITE*BALLE_VITESSE;
						PosBalle[4]=sin(PersoPrincipal.Angle*PI/180)*UNITE*BALLE_VITESSE;
						PosBalle[5]=tan(PersoPrincipal.AngleV*PI/180)*UNITE*BALLE_VITESSE;
						Reseau->EnvoyerMessageBis(MESSAGE_TIR,PersoPrincipal.ID,PosBalle,-1);
						Tir.NouvelleBalle(PersoPrincipal.X,PersoPrincipal.Y,PERSO_HAUTEUR*0.9,cos(PersoPrincipal.Angle*PI/180)*UNITE*BALLE_VITESSE,sin(PersoPrincipal.Angle*PI/180)*UNITE*BALLE_VITESSE,tan(PersoPrincipal.AngleV*PI/180)*UNITE*BALLE_VITESSE,PersoPrincipal.ID);
						TpsTir=BALLE_ATTENTE;
						Son.JouerSon(SON_TIR_NB);
					}
					break;
				}
				break;

			case SDL_ACTIVEEVENT:
				if (((event.active.state & SDL_APPINPUTFOCUS)==SDL_APPINPUTFOCUS)||((event.active.state & SDL_APPACTIVE)==SDL_APPACTIVE))
					BlockageSouris=event.active.gain;	
			
				break;

			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)
				{
				case SDLK_F6:
					return false;						
	
				case SDLK_ESCAPE:
				case SDLK_F2:
					BlockageSouris=1-BlockageSouris; // Active/Desactive le blocakge de la souris
					break;
	
				case SDLK_F1:
				case SDLK_TAB:
					Reseau->AjouterMessageBis(MESSAGE_AFFICHER_SCORE,0,NULL);
					break;

				case SDLK_RETURN:					
					if (!Dire)
					{
						Dire=1;
						BlockageSouris=0;
						Console.DireCommencer();
					}
					else
					{
						char* tmp;

						tmp=Console.DireFinir();
						if (tmp[0]!='\0')
						{							
							Reseau->AjouterMessageBis(MESSAGE_ADIRE,PersoPrincipal.ID,(double*)tmp);
						}
						Dire=0;
						BlockageSouris=1;
						free(tmp);
					}
					break;

				case SDLK_BACKSPACE:
					if (Dire)
						Console.DireEnleverCaractere();
					break;

				default:
					if (Dire)
					{
						

						if (event.key.keysym.sym==SDLK_COMMA)
							Console.DireAjouterCaractere('?');
					
						

						if (event.key.keysym.sym==96)
							Console.DireAjouterCaractere('!');

						if (event.key.keysym.sym==46)
							Console.DireAjouterCaractere('.');

						
						if ((event.key.keysym.sym>=SDLK_KP0)&&(event.key.keysym.sym<=SDLK_KP9))
						{
							Console.DireAjouterCaractere(event.key.keysym.sym-SDLK_KP0+'0');
						}							
							
						if (GetKeyState(0x10) & 32768)
						{
							if ((event.key.keysym.sym>=SDLK_0)&&(event.key.keysym.sym<=SDLK_9))
							{
								Console.DireAjouterCaractere('0'+event.key.keysym.sym-SDLK_0);
							}
							if (((event.key.keysym.sym>='a')&&(event.key.keysym.sym<='z'))||(event.key.keysym.sym==' '))
								Console.DireAjouterCaractere(event.key.keysym.sym+'A'-'a');
						}
						else
						{
							if (event.key.keysym.sym==SDLK_4)
								Console.DireAjouterCaractere('\'');
							if (event.key.keysym.sym==SDLK_2)
								Console.DireAjouterCaractere('$');
							if (((event.key.keysym.sym>='a')&&(event.key.keysym.sym<='z'))||(event.key.keysym.sym==' '))
								Console.DireAjouterCaractere(event.key.keysym.sym);
						}
					}
					break;	
				}
			break;
		 }
	}
	return true;
}

// Gestion des dplacement du perso:
void fenetre::Deplacement()
{
	double TotalX=0;
	double TotalY=0;
	double TotalXTmp=0;
	double TotalYTmp=0;	
	double Tueur=-1;
	bool x=0,y=0;	
	int *Toucheur;
	bool Touche[4]={0,0,0,0};
	int i;
	int Caisse;
	int SonPorte=PORTE_RIEN;
	POINT Apparition;

	double X[CLIENT_MAX+1];
	double Y[CLIENT_MAX+1];
	int j=0;

	if ((BlockageSouris)&&(!Dire))
	{
		if (GetKeyState(0x5A) & 32768) //Z
		{
			x=1;
			Touche[0]=1;
			TotalX+=cos(PI*(double)PersoPrincipal.Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);		
			TotalY+=sin(PI*(double)PersoPrincipal.Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);
		}

		if (GetKeyState(0x53) & 32768) //S
		{
			x=1;
			Touche[1]=1;
			TotalX-=cos(PI*(double)PersoPrincipal.Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);		
			TotalY-=sin(PI*(double)PersoPrincipal.Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);	
		}

		if (GetKeyState(0x51) & 32768) //Q
		{
			y=1;
			Touche[2]=1;
			TotalX+=cos( PI/2+PI*(double)PersoPrincipal.Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);		
			TotalY+=sin( PI/2+PI*(double)PersoPrincipal.Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);
		}

		if (GetKeyState(0x44) & 32768) //D
		{
			y=1;
			Touche[3]=1;
			TotalX+=cos(-PI/2+PI*(double)PersoPrincipal.Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);		
			TotalY+=sin(-PI/2+PI*(double)PersoPrincipal.Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);
		}
	}

	
	Map.CalculColision(TotalX,TotalY,PersoPrincipal.X,PersoPrincipal.Y);
	if(Map.CalculTeleporteur(TotalX,TotalY,PersoPrincipal.X,PersoPrincipal.Y,PersoPrincipal.Angle))
	{
		PersoPrincipal.Duree=500;
		Son.JouerSon(SON_TELEPORTEUR_NB);
	}

	if ( (Caisse=Map.CalculRamassageCaisse(PersoPrincipal.X,PersoPrincipal.Y,PersoPrincipal.Vie,VitesseAnimation.msPassee))!=-1)
	{
		Son.JouerSon(SON_CAISSE_NB);
		Reseau->EnvoyerMessageBis(MESSAGE_CAISSE,Caisse,NULL,-1);
	}
	Toucheur=Tir.CalculeColisionsEtDeplacements(PersoPrincipal.X,PersoPrincipal.Y,VitesseAnimation.msPassee, &Map);

	PersoPrincipal.Mal-=VitesseAnimation.msPassee*VITESSE_MAL;
	if (PersoPrincipal.Mal<0)
		PersoPrincipal.Mal=0;

	for (j=0;j<CLIENT_MAX+1;j++)
	{
		if ((Toucheur[j])&&(j!=PersoPrincipal.ID))
		{
			Reseau->EnvoyerMessageBis(MESSAGE_TOUCHE,j,NULL,-1);
			PersoPrincipal.Vie-=VIE_DEGAT*VIE_MAX*(Toucheur[j]);
			if (PersoPrincipal.Vie<=0)
			{
				if (MortAttente>MORT_ATTENTE)
				{
					
					Tueur=j;
					Reseau->EnvoyerMessageBis(MESSAGE_MORT,PersoPrincipal.ID,&Tueur,-1);
					MortAttente=MORT_ATTENTE;
					PersoPrincipal.X=5000*UNITE;
					PersoPrincipal.Y=5000*UNITE;
					Son.JouerSon(SON_MAL_NB);
					Console.EnvoieConsole("Vous etes mort...");
					PersoPrincipal.Mort=1;
				}
				
			}
			else
			{
				PersoPrincipal.Mal=1;
				Son.JouerSon(SON_MAL_NB);
			}
		}
	}
	if (PersoPrincipal.Mort)
	{


		if (MortAttente>=0)
		{
			MortAttente-=VitesseAnimation.msPassee;
		}

		if (MortAttente<=0)
		{
			MortAttente=MORT_ATTENTE+100;
			Map.ObtenirApparition(&Apparition);
			PersoPrincipal.X=(Apparition.x+0.5)*UNITE;
			PersoPrincipal.Y=(Apparition.y+0.5)*UNITE;
			PersoPrincipal.AngleP=0;
			PersoPrincipal.Angle=0;	
			PersoPrincipal.Vie=VIE_INITIALISATION*VIE_MAX;
			PersoPrincipal.Mort=0;
		}
	}
	else
	{
	}

	// Ouverture des portes:
	j=0;
	X[j]=PersoPrincipal.X;
	Y[j]=PersoPrincipal.Y;
	j++;
	for (i=0;i<CLIENT_MAX+1;i++)
	{
		if (PersoAutre[i].Type==PERSO_TYPE_AUTRE)
		{
			X[j]=PersoAutre[i].X;
			Y[j]=PersoAutre[i].Y;			
			j++;
		}
	}	
	SonPorte=Map.CalculOuverturePorte(j,X,Y,VitesseAnimation.msPassee); // Temporaire aprs il y aura un tableau ac ttes les coord des autres joueurs
	if (Options.SonPorte)
	{
		if (SonPorte==PORTE_OUVRE)
		{
			Son.JouerSon(SON_PORTE_OUVRE_NB);
		}
		if (SonPorte==PORTE_FERME)
		{
			Son.JouerSon(SON_PORTE_FERME_NB);
		}
	}


	if ((x)&&(y))
	{
		TotalX/=1.414;
		TotalY/=1.414;
	}

	PersoPrincipal.X+=TotalX;
	PersoPrincipal.Y+=TotalY;

	// Si on appuis pas sur les meme touche
	if ((PersoPrincipal.Touches[0]!=Touche[0])||(PersoPrincipal.Touches[1]!=Touche[1])||(PersoPrincipal.Touches[2]!=Touche[2])||(PersoPrincipal.Touches[3]!=Touche[3]))
	{
		PersoPrincipal.Duree=500; // On envoie le message position
	}

	// Si on fait un trop gros ecart d'angle
	if ((SigneDe(PersoPrincipal.Angle-PersoPrincipal.AngleP)*(PersoPrincipal.Angle-PersoPrincipal.AngleP))>PERSO_SEUIL_A)
	{
		PersoPrincipal.Duree=500;
		PersoPrincipal.AngleP=PersoPrincipal.Angle;
	}
	
	PersoPrincipal.Touches[0]=Touche[0];
	PersoPrincipal.Touches[1]=Touche[1];
	PersoPrincipal.Touches[2]=Touche[2];
	PersoPrincipal.Touches[3]=Touche[3];

	// Deplacement des autres joueurs	
	Positions.MiseAjourPosition(VitesseAnimation.msPassee);
	for (i=0;i<CLIENT_MAX+1;i++)
	{
		Positions.ObtenirPosition(&PersoAutre[i]);
		if (PersoAutre[i].Type==PERSO_TYPE_AUTRE)
		{
			TotalXTmp=0;
			TotalYTmp=0;
			if (PersoAutre[i].Touches[0]) 
			{
				TotalXTmp+=cos(PI*(double)PersoAutre[i].Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);		
				TotalYTmp+=sin(PI*(double)PersoAutre[i].Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);
			}
		
			if (PersoAutre[i].Touches[1]) 
			{
				TotalXTmp-=cos(PI*(double)PersoAutre[i].Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);		
				TotalYTmp-=sin(PI*(double)PersoAutre[i].Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);	
			}

			if (PersoAutre[i].Touches[2]) 
			{
				TotalXTmp+=cos( PI/2+PI*(double)PersoAutre[i].Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);		
				TotalYTmp+=sin( PI/2+PI*(double)PersoAutre[i].Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);
			}

			if (PersoAutre[i].Touches[3]) 
			{
				TotalXTmp+=cos(-PI/2+PI*(double)PersoAutre[i].Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);		
				TotalYTmp+=sin(-PI/2+PI*(double)PersoAutre[i].Angle/180)*PERSO_VITESSE*double(VitesseAnimation.msPassee);
			}

			if ( ((PersoAutre[i].Touches[1])||(PersoAutre[i].Touches[0]))&&( (PersoAutre[i].Touches[3])||(PersoAutre[i].Touches[2]) ) )
			{
				TotalXTmp/=1.414;
				TotalYTmp/=1.414;
			}
			Map.CalculColision(TotalXTmp,TotalYTmp,PersoAutre[i].X,PersoAutre[i].Y);		
			PersoAutre[i].X+=TotalXTmp;
			PersoAutre[i].Y+=TotalYTmp;
		}
	}

	// Souris:

	CalculDeplacementSouris();

	if ((BlockageSouris)&&(!Dire))
	{
		PersoPrincipal.Angle  -=(double)DeplacementSouris.x*Options.SensibiliteX/PERSO_SOURIS_INV_SENSIBILITE;
		PersoPrincipal.AngleV -=(double)DeplacementSouris.y*Options.SensibiliteY/PERSO_SOURIS_INV_SENSIBILITE;
	}

	if (PersoPrincipal.AngleV>88)	
		PersoPrincipal.AngleV=88;

	if (PersoPrincipal.AngleV<-88)
		PersoPrincipal.AngleV=-88;

	// Colision avec les mur
}

// Rglage de la matrices:
void fenetre::ReglageCamera()
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	// Reglage de la perspective:
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
    gluPerspective(70,(double)Options.LargeurFenetre/Options.HauteurFenetre,UNITE/100,Options.Visibilite*CONSTANTE_VISIBILITE*UNITE);
	
	// Remise  0 
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	// Positionnement de la camra:
	gluLookAt( 0, 0, 0, 1, 0, 0+tan(PersoPrincipal.AngleV*PI/180), 0, 0, 1);
	glRotated( -PersoPrincipal.Angle, 0, 0, 1);	
	glTranslated( -PersoPrincipal.X, -PersoPrincipal.Y, -PERSO_HAUTEUR);
}

// Dessin 
void fenetre::Dessin()
{
	int i;
	bool AfficheNom[CLIENT_MAX+1];
	int Y=0;
	
	
	ReglageCamera();
	
	// Dessin des balles
	Tir.DessineBalles();	

	// Dessin des autres joueurs
	DessinPerso();

	// Dessin de la map	
	Map.Dessin();
	
	// Texte:	
	ReglageAvantTexte(); // On regle la matrice				
		
	DessinMal();
	DessinArme();
	DessinVie();
	Console.AfficheConsole();		

	for (i=0;i<CLIENT_MAX+1;i++)
		AfficheNom[i]=0;

	for (i=0;i<CLIENT_MAX+1;i++)
	{
		if (PersoAutre[i].Type==PERSO_TYPE_AUTRE)
		{
			if (AffichageNom(PersoPrincipal.X,PersoPrincipal.Y,PersoPrincipal.Angle,PersoAutre[i].X,PersoAutre[i].Y))
			{
				AfficheNom[i]=1;
			}
		}
	}

	for (i=0;i<CLIENT_MAX+1;i++)
	{
		if (AfficheNom[i])
		{
			AfficheTexte(AFFICHAGE_NOM_X,AFFICHAGE_NOM_Y+Y,AFFICHAGE_NOM_COULEUR,AFFICHAGE_NOM_TAILLE,PersoAutre[i].Pseudo);
			Y+=AFFICHAGE_NOM_Y_DECALAGE;
		}
	}

	ReglageApresTexte(); // On remet la matrice	
    glFlush();
    SDL_GL_SwapBuffers(); 
}

// Dessine un truc rouge quand on est touch:
void fenetre::DessinMal()
{
	glDisable(GL_TEXTURE_2D);	
	glColor4d(1,0,0,PersoPrincipal.Mal);
	glBegin(GL_QUADS);
	glVertex2i(0	,0);
	glVertex2i(0	,480);
	glVertex2i(640	,480);
	glVertex2i(640	,0);
	glEnd();
	glColor4d(1,1,1,1);
	glEnable(GL_TEXTURE_2D);	
}

// Dessin du pistolet et de la rticule
void fenetre::DessinArme()
{
	glBindTexture(GL_TEXTURE_2D, TextureArme);
	glBegin(GL_QUADS);
	
	glTexCoord2d(0,0);	glVertex2i(300,220);
	glTexCoord2d(1,0);	glVertex2i(340,220);
	glTexCoord2d(1,1);	glVertex2i(340,260);
	glTexCoord2d(0,1);	glVertex2i(300,260);

	glEnd();
}

// Dessin de l'autre joueur:
void fenetre::DessinPerso()
{
	int i;
	for (i=0;i<CLIENT_MAX+1;i++)
	{
		if (PersoAutre[i].Type==PERSO_TYPE_AUTRE)
		{
			DessinerPerso(PersoAutre[i].X,PersoAutre[i].Y,PersoAutre[i].Angle,PersoAutre[i].AngleV,PersoAutre[i].Couleur,TextureJoueur,1);
		}
	}
	DessinerPerso(PersoPrincipal.X,PersoPrincipal.Y,PersoPrincipal.Angle,PersoPrincipal.AngleV,PersoPrincipal.Couleur,TextureJoueur,0);
}

// Dessin de la vie:
void fenetre::DessinVie()	// Faut que le repre soit config comme le texte
{
	glDisable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);

	glColor3d(1,0,0);
	glVertex2i(10,470);
	glVertex2i(10,450);
	glColor3d(0,0,1*PersoPrincipal.Vie/VIE_MAX);
	glVertex2i(10+200*PersoPrincipal.Vie/VIE_MAX,450);
	glVertex2i(10+200*PersoPrincipal.Vie/VIE_MAX,470);
	glColor3d(1,1,1);

	glEnd();
	glEnable(GL_TEXTURE_2D);
}

// Gestion du rseau
void fenetre::GestionReseau()
{
	int i=0,j=0;
	message Msg;
	POINT Pts;
	double Donnees[MESSAGE_PARAMETRE_MAX];
	bool Serveur=Reseau->Serveur;

	if (Serveur)						// Si on est le serveur	
		PersoPrincipal.ID=ID_SERVEUR;		// On met le bon id

	while (Reseau->ObtenirMessage(&Msg)==MESSAGE_ENCORE)
	{
		switch (Msg.Message)
		{
		/////////////////////////////////////////
		// Messages au moment de la connection //
		/////////////////////////////////////////

		// Message ID: 1er message reu par le client au moment de sa connection
		case MESSAGE_ID:												// Si on reoit le message ID
			if (!Serveur)													// Si on est un client
			{
				PersoPrincipal.ID=Msg.Donnees[0];								// On enregistre son id	
				MessageNouveauJoueur(PersoPrincipal.ID,0,Options.Pseudo,Options.Couleur,-1);	// et on envoie le message nouveau joueur au serveur							
			}
			else
				printf("Erreur: reception d'un message ID depuis client\n");	// Pour debuguer...
			break;

		// Message nouveau joueur
		case MESSAGE_NOUVEAU_JOUEUR:									// Si on reoit le message nouveau joueur
			if (!Serveur)													// Si on est client
			{
				
				if ((Msg.IDJoueur!=PersoPrincipal.ID)&&(PersoPrincipal.ID!=-1))	// Si l'ID du nouveau joueur n'est pas le notre et si le notre et dtermin
				{
					printf("\nNouveau joueur id: %d\n>>>",Msg.IDJoueur);			// On affiche nouveau joueur sur la console
					PersoAutre[Msg.IDJoueur].ID=Msg.IDJoueur;						// Sa sa sert un peu  rien... mais faut bien le faire une fois
					PersoAutre[Msg.IDJoueur].Type=PERSO_TYPE_AUTRE;					// Pour dire que le perso est utilis
				}
			}

			else														// Si on est serveur
			{
				printf("\nNouveau joueur id: %d\n\n>>>",Msg.IDJoueur);
				PersoAutre[Msg.IDJoueur].ID=Msg.IDJoueur;					// Sa sa sert un peu  rien... mais faut bien le faire une fois
				PersoAutre[Msg.IDJoueur].Type=PERSO_TYPE_AUTRE;				// Pour dire que le perso est utilis
				MessageNouveauJoueur(ID_SERVEUR,PersoPrincipal.Score,Options.Pseudo,Options.Couleur,Msg.IDJoueur);	// On lui envoie les donnes sur sois-mme
				for (j=0;j<CLIENT_MAX;j++)									// Pour chaque client
				{
					if (PersoAutre[j].Type==PERSO_TYPE_AUTRE)					// S'il est utilis
					{
						if (j!=Msg.IDJoueur)										// Et si c'est pas lui...
						{
							MessageNouveauJoueur(j,PersoAutre[j].Score,PersoAutre[j].Pseudo,PersoAutre[i].Couleur,Msg.IDJoueur);	// On lui envoie les donnes sur ce dernier		
						
						}
					}
				}
				MessageNouveauJoueur(Msg.IDJoueur,0,PSEUDO_DEFAUT,0,-1);		// On envoie le message au autres joueurs
				Reseau->EnvoyerMessageBis(MESSAGE_MAP,this->NumMap,(double*)this->NomMap,Msg.IDJoueur);
			}
				
			break;

		// Ya mme des pseudo ^^
		case MESSAGE_PSEUDO:
			memcpy(PersoAutre[Msg.IDJoueur].Pseudo,Msg.Donnees,sizeof(double)*MESSAGE_PARAMETRE_MAX);	// On copie le pseudo
			if (strcmp(PSEUDO_DEFAUT,PersoAutre[Msg.IDJoueur].Pseudo))											// Si s'est pas le pseudo par defaut
				Console.EnvoieConsole("%s tente sa chance!",PersoAutre[Msg.IDJoueur].Pseudo);						// On affiche bienvenue!
			if (Serveur)
				Reseau->EnvoyerMessageBis(MESSAGE_PSEUDO,Msg.IDJoueur,Msg.Donnees,-1);					// Et si on est le serveur on retransmet le message
			break;


		case MESSAGE_MAP:
			if (!Serveur)
			{
				Map.ChargeMap((char*)Msg.Donnees,1,Msg.IDJoueur);
				Map.ObtenirApparition(&Pts);
				PersoPrincipal.X=(Pts.x+0.5)*UNITE;
				PersoPrincipal.Y=(Pts.y+0.5)*UNITE;
			}
			break;

		case MESSAGE_COULEUR:
			PersoAutre[Msg.IDJoueur].Couleur=Msg.Donnees[0];
			if (Serveur)
				Reseau->EnvoyerMessageBis(MESSAGE_COULEUR,Msg.IDJoueur,Msg.Donnees,-1);
		break;

		case MESSAGE_DATE:
			strcpy(PersoAutre[Msg.IDJoueur].Date,(char*)Msg.Donnees);
			break;

		case MESSAGE_MAP_NOUVELLE:			
			if (Serveur)
				Map.ChargeMap((char*)Msg.Donnees,1,Msg.IDJoueur);
			this->NumMap=Msg.IDJoueur;
			strcpy(this->NomMap,(char*)Msg.Donnees);
			Reseau->EnvoyerMessageBis(MESSAGE_MAP,this->NumMap,(double*)this->NomMap,-1);
			Map.ObtenirApparition(&Pts);
			PersoPrincipal.X=(Pts.x+0.5)*UNITE;
			PersoPrincipal.Y=(Pts.y+0.5)*UNITE;
			break;
		////////////////////////////
		// Messages durant le jeu //
		////////////////////////////

		case MESSAGE_CAISSE:
			Map.RamasseCaisse(Msg.IDJoueur);
			if (Serveur)
			{
				Reseau->EnvoyerMessageBis(MESSAGE_CAISSE,Msg.IDJoueur,NULL,-1);
			}
			break;

		case MESSAGE_TOUCHE:
			if (Msg.IDJoueur==PersoPrincipal.ID)
			{
				Son.JouerSon(SON_TOUCHE_NB);
			}
			if (Serveur)
			{
				Reseau->EnvoyerMessageBis(MESSAGE_TOUCHE,Msg.IDJoueur,NULL,-1);
			}
			break;				

		case MESSAGE_ADIRE:
			Reseau->EnvoyerMessageBis(MESSAGE_DIRE,PersoPrincipal.ID,Msg.Donnees,-1);
			if (Serveur)
			{
				Console.EnvoieConsole("%s:%s",Options.Pseudo,(char*)&Msg.Donnees);
				printf("\n%s:%s\n\n>>>",Options.Pseudo,(char*)&Msg.Donnees);
			}
			break;

		case MESSAGE_DIRE:
			Console.EnvoieConsole("%s:%s",PersoAutre[Msg.IDJoueur].Pseudo,(char*)&Msg.Donnees);
			printf("\n%s:%s\n\n>>>",PersoAutre[Msg.IDJoueur].Pseudo,(char*)&Msg.Donnees);
			if (Serveur)
			{
				Reseau->EnvoyerMessageBis(MESSAGE_DIRE,Msg.IDJoueur,Msg.Donnees,-1);
			}
			break;

		case MESSAGE_AEXPULSE:
			PersoAutre[Msg.IDJoueur].Type=PERSO_TYPE_INUTILISE;
			if (Serveur)
			{
				Reseau->EnvoyerMessageBis(MESSAGE_EXPULSE,0,NULL,Msg.IDJoueur);
			}
			break;

		case MESSAGE_AFFICHER_SCORE:
			printf("Score:");
			for (j=0;j<CLIENT_MAX+1;j++)
			{
				if (PersoAutre[j].Type==PERSO_TYPE_AUTRE)
				{
					if (j!=PersoPrincipal.ID)
					{
						printf("\nScore de %s(%d)=%d",PersoAutre[j].Pseudo,j,PersoAutre[j].Score);
						Console.EnvoieConsole("Score de %s=%d",PersoAutre[j].Pseudo,PersoAutre[j].Score);
					}
				}
			}
			printf("\nMon score (%d)=%d!!\n\n>>>",PersoPrincipal.ID,PersoPrincipal.Score);
			Console.EnvoieConsole("Mon score=%d!!",PersoPrincipal.Score);
			break;			

		case MESSAGE_EXPULSE:
			if (!Serveur)	// Sinon on pourrait expulser le serveur o_O'
				Expulse=1;
			break;

		case MESSAGE_POSITION:			

			if (PersoAutre[Msg.IDJoueur].Type==PERSO_TYPE_AUTRE) // Si c'est un joueur
			{
				if (Serveur)
				{
					if (strcmp(PersoAutre[Msg.IDJoueur].Date,__TIME__))
					{
						Expulsion[Msg.IDJoueur]++;
						if (Expulsion[Msg.IDJoueur]>SEUIL_EXPULSION)						
							Reseau->AjouterMessageBis(MESSAGE_AEXPULSE,Msg.IDJoueur,NULL);						
					}
					else					
						Expulsion[Msg.IDJoueur]=0;					
				}			
					if (Options.AmeliorationFluidite) 
						Positions.AjouterPositionBis(Msg.Donnees[1],Msg.IDJoueur,Msg.Donnees[2],Msg.Donnees[3],Msg.Donnees[4],Msg.Donnees[5],(bool*)&Msg.Donnees[0]);			
					else
						CopierPosition(Msg.IDJoueur,Msg.Donnees[2],Msg.Donnees[3],Msg.Donnees[4],Msg.Donnees[5],(bool*)&Msg.Donnees[0]);
			}
			
			if (Serveur)
				Reseau->EnvoyerMessageBis(MESSAGE_POSITION,Msg.IDJoueur,Msg.Donnees,-1);
			break;

		case MESSAGE_TIR:		
			
			if (PersoAutre[Msg.IDJoueur].Type==PERSO_TYPE_AUTRE)
			{
				Tir.NouvelleBalle(Msg.Donnees[0],Msg.Donnees[1],Msg.Donnees[2],Msg.Donnees[3],Msg.Donnees[4],Msg.Donnees[5],Msg.IDJoueur);
				if (Serveur)
					Reseau->EnvoyerMessageBis(MESSAGE_TIR,Msg.IDJoueur,Msg.Donnees,-1);
			}
			
			break;

		// Pour envoyer le score...
		case MESSAGE_SCORE:
			PersoAutre[Msg.IDJoueur].Score=Msg.Donnees[0];
			if (Serveur)
				Reseau->EnvoyerMessageBis(MESSAGE_SCORE,Msg.IDJoueur,Msg.Donnees,-1);
			break;

		case MESSAGE_MORT:
			if (PersoPrincipal.ID==Msg.Donnees[0])
			{
				printf("Vous gagnez un point!\n>>>");
				Console.EnvoieConsole("Vous venez d'occire %s",PersoAutre[Msg.IDJoueur].Pseudo);
				PersoPrincipal.Score++;
				Donnees[0]=PersoPrincipal.Score;
				Reseau->EnvoyerMessageBis(MESSAGE_SCORE,PersoPrincipal.ID,Donnees,-1);
				char Texte[LONGUEUR_MAX];
				int Choix;
				Choix=(int)Random(5);
				switch (Choix)
				{
				case 0:
					sprintf(Texte,"%s n'etait pas assez fort\n",PersoAutre[Msg.IDJoueur].Pseudo);
					break;
				case 1:
					sprintf(Texte,"%s admet son inferiorite\n",PersoAutre[Msg.IDJoueur].Pseudo);
					break;
				case 2:
					sprintf(Texte,"%s est vraiment un noob...\n",PersoAutre[Msg.IDJoueur].Pseudo);
					break;
				case 3:
					sprintf(Texte,"Tu me decois %s\n",PersoAutre[Msg.IDJoueur].Pseudo);
					break;
				case 4:
					sprintf(Texte,"Prend pas la quinte %s...\n",PersoAutre[Msg.IDJoueur].Pseudo);
					break;
				}
				Reseau->AjouterMessageBis(MESSAGE_ADIRE,0,(double*)Texte);
			}

			if (Serveur)
				Reseau->EnvoyerMessageBis(MESSAGE_MORT,Msg.IDJoueur,Msg.Donnees,-1);
			break;

		case MESSAGE_RESET:
			printf("Remise a 0 des scores\n");
			PersoPrincipal.Score=0;
			Donnees[0]=PersoPrincipal.Score;
			Reseau->EnvoyerMessageBis(MESSAGE_SCORE,PersoPrincipal.ID,Donnees,-1);
			if (Serveur)
				Reseau->EnvoyerMessageBis(MESSAGE_RESET,Msg.IDJoueur,Msg.Donnees,-1);
			break;

		///////////////////////////////////////////
		// Messages au moment de la deconnection //
		///////////////////////////////////////////

		// Deconnection:
		case MESSAGE_DECONNECTION:
			PersoAutre[Msg.IDJoueur].Type=PERSO_TYPE_INUTILISE;
			Console.EnvoieConsole("%s a pris la quinte...",PersoAutre[Msg.IDJoueur].Pseudo);
			if (Serveur)
				Reseau->EnvoyerMessageBis(MESSAGE_DECONNECTION,Msg.IDJoueur,Msg.Donnees,-1);
			break;

		case MESSAGE_HOTE_DECONNECTE:
			Console.EnvoieConsole("L'hote a pris la quinte...");
			break;

		} // fin du switch
	}// fin du while


	////////////////////////
	// Envoie des donnes //
	////////////////////////

	PersoPrincipal.Duree+=VitesseAnimation.msPassee;
	if (PersoPrincipal.Duree>=500) 
	{
		PersoPrincipal.Duree=0;
		memcpy(Msg.Donnees,PersoPrincipal.Touches,sizeof(bool)*4);
		Msg.Donnees[1]=SDL_GetTicks();
		Msg.Donnees[2]=PersoPrincipal.X				;
		Msg.Donnees[3]=PersoPrincipal.Y				;
		Msg.Donnees[4]=PersoPrincipal.Angle			;
		Msg.Donnees[5]=PersoPrincipal.AngleV		;
		Reseau->EnvoyerMessageBis(MESSAGE_POSITION,PersoPrincipal.ID,Msg.Donnees,-1);
	}	
}// la on s'en doute...

void fenetre::CopierPosition(int NPerso,double X,double Y,double Angle,double AngleV,bool* Touches)
{
	int i=0;

	PersoAutre[NPerso].Angle=Angle;
	PersoAutre[NPerso].AngleV=AngleV;
	PersoAutre[NPerso].X=X;
	PersoAutre[NPerso].Y=Y;
	for (i=0;i<4;i++)
		PersoAutre[NPerso].Touches[i]=Touches[i];
}

// Initialisation du perso principal:
void fenetre::InitialisationPerso()
{
	POINT Apparition;
	int i;

	// Perso principal:
	Map.ObtenirApparition(&Apparition);
	PersoPrincipal.ID=-1;
	PersoPrincipal.AngleV=0;
	PersoPrincipal.Angle=0;
	PersoPrincipal.AngleP=0;
	PersoPrincipal.Mal=0;
	PersoPrincipal.Vie=VIE_INITIALISATION*VIE_MAX;
	PersoPrincipal.Couleur=Options.Couleur;
	if (Reseau->Serveur)	// Sinon sa se fait quand on recoi le message map
	{
		PersoPrincipal.X=(Apparition.x+0.5)*UNITE;
		PersoPrincipal.Y=(Apparition.y+0.5)*UNITE;
	}
	PersoPrincipal.Type=PERSO_TYPE_SOI;
	PersoPrincipal.Score=0;
	PersoPrincipal.Duree=0;
	PersoPrincipal.Mort;

	// Autres persos	
	for (i=0;i<CLIENT_MAX;i++)
	{
		PersoAutre[i].Type=PERSO_TYPE_INUTILISE;
	}
}

// Calcul du temps  attendre et de la vitesse
void fenetre::GestionTemps()
{
	TpsTir-=VitesseAnimation.msPassee;
	TempsAttente.CalculerTempsEcoule();
	Sleep( (1000/Fps-TempsAttente.msPassee)*(1000/Fps-TempsAttente.msPassee>=0) ); // si c'est infrieur  0 on attend pas...
	VitesseAnimation.CalculerTempsEcoule();
	TempsAttente.CalculerTempsEcoule();
}

// Calcul des pixel de qu'a parcouru la souris depuis la dernire fois
void fenetre::CalculDeplacementSouris()
{
	GetCursorPos(&PositionSouris);
	DeplacementSouris.x=PositionSouris.x-SOURIS_POSX;
	DeplacementSouris.y=PositionSouris.y-SOURIS_POSY;

	if ((BlockageSouris)&&(!Dire))
	{
		SDL_ShowCursor(SDL_DISABLE);
		SetCursorPos( SOURIS_POSX, SOURIS_POSY);
	}
	else
	{
		SDL_ShowCursor(SDL_ENABLE);
	}
}

// Envoie de message:

// Nouveau joueur
void fenetre::MessageNouveauJoueur(int ID, int Score, char* Pseudo,int Couleur,int NDest)
{
	double Parametres[MESSAGE_PARAMETRE_MAX];
	Reseau->EnvoyerMessageBis(MESSAGE_NOUVEAU_JOUEUR,ID,NULL,NDest);	// On envoie le message nouveau message
	memcpy(Parametres,Pseudo,sizeof(double)*MESSAGE_PARAMETRE_MAX);		// On copie le pseudo
	Reseau->EnvoyerMessageBis(MESSAGE_PSEUDO,ID,Parametres,NDest);		// On envoie le pseudo
	strcpy( (char*)Parametres, __TIME__);
	Reseau->EnvoyerMessageBis(MESSAGE_DATE,PersoPrincipal.ID,Parametres,NDest);
	Parametres[0]=Score;											
	Reseau->EnvoyerMessageBis(MESSAGE_SCORE,ID,Parametres,NDest);		// On envoie le score
	Parametres[0]=Couleur;											
	Reseau->EnvoyerMessageBis(MESSAGE_COULEUR,ID,Parametres,NDest);		// On envoie le score
}
