#include "jeu.h"

////////////////
// Variables: //
////////////////

// Pour le thread fenetre:
DWORD ThreadFenetreMain;
DWORD ThreadServeurPrincipale;
DWORD ThreadClientRecevoir;
DWORD ThreadClientEnvoyer;
parametres Parametres;

// Quelques globales:
char AdresseIP[16];	

////////////////
// Fonctions: //
////////////////

// Constructeur de jeu:
jeu::jeu()
{
	InitialisationFaite=0;
}

// Initialisation gnrale:
int jeu::Initialisation()
{
	int Erreur=0;

	if (InitialisationFaite) // Si c'est dja intialis on retourne un nombre ngatif 
		return -1;

	printf("Initialisation...\n");

		 // si il y a une erreur on met +1 dans Erreur
	Erreur+=(InitialisationDiver()==ERREUR_ERREUR);
	if (Erreur==0)
		Erreur+=(Options.ChargeOptions()==ERREUR_ERREUR);
	if (Erreur==0)		
		Erreur+=(InitialisationMap()==ERREUR_ERREUR);
	if (Erreur==0)
		Erreur+=InitialisationConnection();
	if (Erreur==0)
		Erreur+=(InitialisationOpenGL()==ERREUR_ERREUR);

	if (!Erreur)
		InitialisationFaite=1;		
	
	return Erreur;
}

// Initialisation d'OpenGL et SDL:
int jeu::InitialisationOpenGL()
{
	int NumMap=-1;

	printf("Initialisation de la fenetre\n");

	if (NombreDeMap==0)
	{
		printf("Erreur: aucune map n'existe\n");
		return ERREUR_ERREUR;
	}
	
	if (Reseau.Serveur)
	{
		printf("Entrez le numero de la map:");
		scanf("%d",&NumMap);
	}

	Parametres.Opts=Options;
	Parametres.NomDeLaMap=ListeDesMap[NumMap];
	Parametres.NumeroMap=NumMap;
	Parametres.Reseau=&Reseau;

	if (CreateThread(NULL,NULL,FenetreMain,&Parametres,NULL,&ThreadFenetreMain)!=NULL)
		CloseHandle(FenetreMain);
	
	return ERREUR_AUCUNE;
}

// Chargement de la liste des map:
int jeu::InitialisationMap()
{
	int Erreur=-1;
	int i=0;

	printf("Listage des map...\n");
	Erreur=Lister(MAP_NOM_FICHIER,(char*) ListeDesMap, &NombreDeMap);
	if (Erreur==ERREUR_AUCUNE)
		for (i=0;i<NombreDeMap;i++)
			printf("%s\n",ListeDesMap[i]);
	Map.InitialisationMap();
	return Erreur;
}

// Affichage de la liste des map:
void jeu::AfficheListeMap()
{
	int i;
	char ListeDesNomsDeTextures[LISTE_NOMBRE_MAX][LISTE_NOM_TAILLE_MAX];
	int NombreDeTextures;

	Lister(MAP_NOM_FICHIER, (char*) ListeDesNomsDeTextures, &NombreDeTextures);

	for (i=0;i<NombreDeTextures;i++)
		printf("%s\n",ListeDesNomsDeTextures[i]);
}

// Affichage de la liste des textures:
void jeu::AfficheListeTextures()
{
	int i;
	char ListeDesNomsDeTextures[LISTE_NOMBRE_MAX][LISTE_NOM_TAILLE_MAX];
	int NombreDeTextures;

	Lister(TEXTURE_NOM_FICHIER, (char*) ListeDesNomsDeTextures, &NombreDeTextures);

	for (i=0;i<NombreDeTextures;i++)
		printf("%s\n",ListeDesNomsDeTextures[i]);	
}

// Affichage les caractristique d'une map
void jeu::TesterMap(int num)
{
	if (!InitialisationFaite)
	{
		printf("Erreur: Impossible d'afficher la map\n");
		printf("L'initialisation du jeu n'a pas ete faite ou a echoue\n");
		printf("Tapez start pour lancer l'initialisation\n");
	}
	else if ((num>=NombreDeMap)||(num<0))
	{
		printf("Erreur: La map %d est inexistante\n",num);
	}
	
	else	
	{
		Map.ChargeMap(ListeDesMap[num], 0, 0);
	}
}

// Initialisation des evenements:
int jeu::InitialisationDiver()
{
	return ERREUR_AUCUNE;
}

// Conection:
int jeu::InitialisationConnection()
{
	char Choix;
	int Port=PORT_DEFAUT;
	SOCKET Socket;
	SOCKADDR_IN Sin;
	WSADATA WSAData;	
	
	printf("Initialisation de la connection\n");
	printf("Serveur ou client?(s/c):");
	scanf("%c",&Choix);

	if (Choix=='s')
	{	
		do	// On choisi un port	
		{
			printf("Entrez le port:");
			scanf("%d",&Port);
		}	
		while ((Port>65535)||(Port<0)); 		

		Reseau.Initialisation(1,NULL,Port);
	}

	else
	{
		printf("Entrez l'addresse IP du serveur:"); // On prend l'adresse IP
		scanf("%s",AdresseIP);
		do	// On choisi un port	
		{
			printf("Entrez le port:");
			scanf("%d",&Port);
		}	
		while ((Port>65535)||(Port<0)); 		
		WSAStartup(MAKEWORD(2,0), &WSAData);	
		Sin.sin_addr.s_addr	= inet_addr(AdresseIP); 
		Sin.sin_family		= AF_INET;
		Sin.sin_port		= htons(Port);
		Socket = socket(AF_INET,SOCK_STREAM,0);
		bind(Socket, (SOCKADDR *)&Sin, sizeof(Sin));
	
		printf("Tentative de connection sur %s:%d\n",AdresseIP,Port);

		if (connect(Socket, (SOCKADDR *)&Sin, sizeof(Sin))==0) // Connection
		{
			printf("Connection Reussie\n");
		}
		else
		{
			printf("Echec de la connection\n");
			return ERREUR_ERREUR;
		}

		Reseau.Initialisation(0,Socket,-1);
	}

	return ERREUR_AUCUNE;	
}

void jeu::Dire(char *Texte)
{	
	if (InitialisationFaite)
		Reseau.AjouterMessageBis(MESSAGE_ADIRE,0,(double*)Texte);
}

void jeu::AfficherScore()
{
	if (InitialisationFaite)
		Reseau.AjouterMessageBis(MESSAGE_AFFICHER_SCORE,0,NULL);
}

void jeu::ChargeMap(int N)
{
	char ListeDesNomsDeMap[LISTE_NOMBRE_MAX][LISTE_NOM_TAILLE_MAX];
	int NombreDeMap;
	Lister(MAP_NOM_FICHIER, (char*) ListeDesNomsDeMap, &NombreDeMap);
	if ((N<0)||(N>=NombreDeMap))
	{
		printf("Erreur: Map inexistante\n");
		return;
	}
	if (Reseau.Serveur)
		Reseau.AjouterMessageBis(MESSAGE_MAP_NOUVELLE,N,(double*)ListeDesNomsDeMap[N]);
	else
		printf("Erreur: vous n'etes pas le serveur\n");
}	

void jeu::Expulser(int Num)
{
	if (InitialisationFaite)
	{
		if (Reseau.Serveur)
			Reseau.AjouterMessageBis(MESSAGE_AEXPULSE,Num,NULL);
		else
		{
			printf("tssssss...\n");
			printf("pour la peine vous allez etre expulse dans 5 sec\n");
			printf("5\n");
			Sleep(1000);
			printf("4\n");
			Sleep(1000);
			printf("3\n");
			Sleep(1000);
			printf("2\n");
			Sleep(1000);
			printf("1\n");
			Sleep(1000);
			printf("BOOOOOM\nhinhin c'etait une blague^^\n\n>>>");
		}
	}
}

	
void jeu::ResetScore()
{
	if (Reseau.Serveur)
	{
		Reseau.AjouterMessageBis(MESSAGE_RESET,0,NULL);		
	}
	else 
		printf("Erreur: vous n'etes pas le serveur\n");
}

