#include "map.h"

////////////////
// Fonctions: //
////////////////

int map::ChargeMap(char* Nom,bool Charge,int NumMap)
{
	unsigned long i=0;
	unsigned long Taille;
	unsigned int Texture[TEXTURE_PARAMETRE]={0,1};
	char *Texte;
	char C=0;
	int Nombres1[3]={0,0,0};
	int Nombres2[3]={0,0,0};
	int Nombres3[3]={0,0,0};
	int Balise;	
	int BaliseTmp; // s'il y en a une deuxime identique aprs		
	
	if (Charge)
	{
		if (MapChargee)
		{
			printf("Effacement des textures\n");
			glDeleteTextures(NombreDeTextures,ListeDesTextures); // On efface les texture
		}
		NombreDeTextures=0;
		printf("On charge la map %s de numero %d\n",Nom,NumMap);
		if (InitialisationTextures(NumMap)!=ERREUR_AUCUNE)
			return ERREUR_ERREUR;
	}	

	InitialisationMap();

	Texte=OuvrirFichier(Nom,&Taille);
	if (Texte==NULL)
		return ERREUR_ERREUR;

	i=0;
	Balise=ObtenirBalise(Texte,i,Taille);
	while ((Balise!=BALISE_FIN)&&(Balise!=BALISE_INCOMPLETE))
	{
		if (Balise==BALISE_ERREUR)
		{
			printf("Une balise incorrecte a ete detecte la map ne peut pas fonctionner\n");
			return ERREUR_ERREUR;
		}

		else if (Balise==BALISE_APPARITION)
		{
			BaliseTmp=ObtenirParametre(PARAMETRE_INT_INT,Texte,i,Taille,Texture,C,Nombres1);
			if (BaliseTmp!=BALISE_FIN)		
			{
				if (!Charge)
					printf("Apparition aux coordonnees: (%d,%d)\n",Nombres1[0],Nombres1[1]);
				// Et si on charge la map:
				if (Charge)
				{
					Apparition[NbApparition][APPARITION_X]=Nombres1[0];
					Apparition[NbApparition][APPARITION_Y]=Nombres1[1];

					NbApparition++;
					if (NbApparition>=APPARITION_MAX-1) 
						NbApparition=APPARITION_MAX-1;
				}

			}
		}

		else if (Balise==BALISE_PLAFON)
		{
			BaliseTmp=ObtenirParametre(PARAMETRE_INT,Texte,i,Taille,Texture,C,Nombres1);
			BaliseTmp=ObtenirParametre(PARAMETRE_INT_INT,Texte,i,Taille,Texture,C,Nombres2);
			BaliseTmp=ObtenirParametre(PARAMETRE_INT_INT,Texte,i,Taille,Texture,C,Nombres3);
			if (BaliseTmp!=BALISE_FIN)	
			{
				if (!Charge)
					printf("Plafon d'une hauteur de: %d faisant un rectangle allant de (%d,%d) a (%d,%d)\n",Nombres1[0],Nombres2[0],Nombres2[1],Nombres3[0],Nombres3[1]);
				// Et si on charge la map:
				if (Charge)
				{
					Plafon[NbPlafon][PLAFON_TEXTURE]=Texture[TEXTURE_NUMERO];
					Plafon[NbPlafon][PLAFON_TEXTURE_REPETITION]=Texture[TEXTURE_REPETITION];
					Plafon[NbPlafon][PLAFON_HAUTEUR]=Nombres1[0];
					Plafon[NbPlafon][PLAFON_X1]=Nombres2[0];
					Plafon[NbPlafon][PLAFON_Y1]=Nombres2[1];
					Plafon[NbPlafon][PLAFON_X2]=Nombres3[0];
					Plafon[NbPlafon][PLAFON_Y2]=Nombres3[1];

					if (Plafon[NbPlafon][PLAFON_X1]>Plafon[NbPlafon][PLAFON_X2])
					{
						int tmp=Plafon[NbPlafon][PLAFON_X1];
						Plafon[NbPlafon][PLAFON_X1]=Plafon[NbPlafon][PLAFON_X2];
						Plafon[NbPlafon][PLAFON_X2]=tmp;
					}

					if (Plafon[NbPlafon][PLAFON_Y1]>Plafon[NbPlafon][PLAFON_Y2])
					{
						int tmp=Plafon[NbPlafon][PLAFON_Y1];
						Plafon[NbPlafon][PLAFON_Y1]=Plafon[NbPlafon][PLAFON_Y2];
						Plafon[NbPlafon][PLAFON_Y2]=tmp;
					}

					if ((Plafon[NbPlafon][PLAFON_X1]!=Plafon[NbPlafon][PLAFON_X2])&&(Plafon[NbPlafon][PLAFON_Y1]!=Plafon[NbPlafon][PLAFON_Y2]))
					{
						NbPlafon++;
						if (NbPlafon>=PLAFON_MAX-1) // Pour pas qu'on dpace le nombre max de plafon
							NbPlafon=PLAFON_MAX-1;
					}
				}
			}
		}

		else if (Balise==BALISE_MUR)
		{
			BaliseTmp=ObtenirParametre(PARAMETRE_CHAR_INT_INT_INT,Texte,i,Taille,Texture,C,Nombres1);
			BaliseTmp=ObtenirParametre(PARAMETRE_INT_INT, Texte, i, Taille, Texture, C, Nombres2);
			if (BaliseTmp!=BALISE_FIN)
			{
				if (!Charge)
				{
					if (C=='h')
						printf("Mur horizontal avec y=%d allant de x=%d a x=%d d'une hauteur min %d et max %d\n",Nombres1[0],Nombres1[1],Nombres1[2], Nombres2[0], Nombres2[1]);
					else
						printf("Mur Vertical   avec x=%d allant de y=%d a y=%d d'une hauteur min %d et max %d\n",Nombres1[0],Nombres1[1],Nombres1[2], Nombres2[0], Nombres2[1]);
				}
				if (Charge)
				{ 					
					Mur[NbMur][MUR_TEXTURE]=Texture[TEXTURE_NUMERO];
					Mur[NbMur][MUR_TEXTURE_REPETITION]=Texture[TEXTURE_REPETITION];
					Mur[NbMur][MUR_TYPE]=(int)C;
					
					Mur[NbMur][MUR_XY_POS]=Nombres1[0];
					Mur[NbMur][MUR_XY_MIN]=Nombres1[1];
					Mur[NbMur][MUR_XY_MAX]=Nombres1[2];

					Mur[NbMur][MUR_Z_MIN]=Nombres2[0];
					Mur[NbMur][MUR_Z_MAX]=Nombres2[1];

					if (Mur[NbMur][MUR_XY_MIN]>Mur[NbMur][MUR_XY_MAX])
						InverseInt(Mur[NbMur][MUR_XY_MIN],Mur[NbMur][MUR_XY_MAX]);
					if (Mur[NbMur][MUR_Z_MIN]>Mur[NbMur][MUR_Z_MAX]	)
						InverseInt(Mur[NbMur][MUR_Z_MIN],Mur[NbMur][MUR_Z_MAX]);

					if ((Mur[NbMur][MUR_XY_MIN]!=Mur[NbMur][MUR_XY_MAX])&&(Mur[NbMur][MUR_Z_MIN]!=Mur[NbMur][MUR_Z_MAX]	))
					{
						NbMur++;
						if (NbMur>=MUR_MAX-1) // Pour pas qu'on dpace le nombre max de mur
							NbMur=MUR_MAX-1;
					}
				}
			}
		}

		else if (Balise==BALISE_TELEPORTEUR)
		{
			BaliseTmp=ObtenirParametre(PARAMETRE_CHAR_INT_INT_INT,Texte,i,Taille,Texture,C,Nombres1);
			BaliseTmp=ObtenirParametre(PARAMETRE_INT_INT,Texte,i,Taille,Texture,C,Nombres2);
			if (BaliseTmp!=BALISE_FIN)
			{
				if (!Charge)
				{
					if (C=='h')
						printf("Teleporteur horizontal allant de (%d,%d) a (%d,%d)\n",Nombres1[0],Nombres1[1],Nombres2[0],Nombres2[1]);
					else
						printf("Teleporteur vertical allant de (%d,%d) a (%d,%d)\n",Nombres1[0],Nombres1[1],Nombres2[0],Nombres2[1]);
				}

				if (Charge)
				{
					Teleporteur[NbTeleporteur][TELEPORTEUR_TEXTURE]=Texture[TEXTURE_NUMERO];
					Teleporteur[NbTeleporteur][TELEPORTEUR_SENS]=(int)C;					
					Teleporteur[NbTeleporteur][TELEPORTEUR_POS_X]=Nombres1[0];
					Teleporteur[NbTeleporteur][TELEPORTEUR_POS_Y]=Nombres1[1];
					Teleporteur[NbTeleporteur][TELEPORTEUR_ANGLE]=Nombres1[2];
					Teleporteur[NbTeleporteur][TELEPORTEUR_D_X]=Nombres2[0];
					Teleporteur[NbTeleporteur][TELEPORTEUR_D_Y]=Nombres2[1];

					NbTeleporteur++;
					if (NbTeleporteur>=MUR_MAX-1) // Pour pas qu'on dpace le nombre max de plafon
						NbTeleporteur=MUR_MAX-1;
				}
			}
		}

		else if (Balise==BALISE_PORTE)
		{
			BaliseTmp=ObtenirParametre(PARAMETRE_CHAR_INT_INT_INT,Texte,i,Taille,Texture,C,Nombres1);
			BaliseTmp=ObtenirParametre(PARAMETRE_INT_INT, Texte, i, Taille, Texture, C, Nombres2);
			if (BaliseTmp!=BALISE_FIN)
			{	
				if (!Charge)
				{	
					if (C=='h')
						printf("Porte horizontale avec y=%d allant de x=%d a x=%d d'une hauteur min %d et max %d\n",Nombres1[0],Nombres1[1],Nombres1[2], Nombres2[0], Nombres2[1]);
					else
						printf("Porte Verticale   avec x=%d allant de y=%d a y=%d d'une hauteur min %d et max %d\n",Nombres1[0],Nombres1[1],Nombres1[2], Nombres2[0], Nombres2[1]);
				}
				if (Charge)
				{ 				
					Porte[NbPorte][PORTE_TEXTURE]=Texture[TEXTURE_NUMERO];
					Porte[NbPorte][PORTE_TYPE]=(int)C;
					
					Porte[NbPorte][PORTE_XY_POS]=Nombres1[0];
					Porte[NbPorte][PORTE_XY_MIN]=Nombres1[1];
					Porte[NbPorte][PORTE_XY_MAX]=Nombres1[2];
					
					Porte[NbPorte][PORTE_Z_MIN]=Nombres2[0];
					Porte[NbPorte][PORTE_Z_MAX]=Nombres2[1];
					Porte[NbPorte][PORTE_HAUTEUR_VAR]=0;

					if (Porte[NbPorte][PORTE_Z_MIN]>Porte[NbPorte][PORTE_Z_MAX])
					{
						int a=Porte[NbPorte][PORTE_Z_MIN];
						Porte[NbPorte][PORTE_Z_MIN]=Porte[NbPorte][PORTE_Z_MAX];
						Porte[NbPorte][PORTE_Z_MAX]=a;
					}

					if ((Porte[NbPorte][PORTE_XY_MIN]!=Porte[NbPorte][PORTE_XY_MAX])&&(Porte[NbPorte][PORTE_Z_MIN]!=Porte[NbPorte][PORTE_Z_MAX]))
					{
						NbPorte++;
						if (NbPorte>=MUR_MAX-1) 
							NbPorte=MUR_MAX-1;
					}
				}
			}
		}

		else if (Balise==BALISE_CAISSE)
		{
			BaliseTmp=ObtenirParametre(PARAMETRE_INT_INT,Texte,i,Taille,Texture,C,Nombres1);
			if (BaliseTmp!=BALISE_FIN)
			{	
				if (!Charge)
				{			
					printf("Caisse de soin aux coordonnees: (%d,%d) avec la texture %d\n",Nombres1[0],Nombres1[1],Texture);
				}

				if (Charge)
				{ 
					Caisse[NbCaisse][CAISSE_TEXTURE]=Texture[TEXTURE_NUMERO];
					
					Caisse[NbCaisse][CAISSE_POS_X]=Nombres1[0];
					Caisse[NbCaisse][CAISSE_POS_Y]=Nombres1[1];
					
					Caisse[NbCaisse][CAISSE_TEMPS_RESTANT]=0;
					Caisse[NbCaisse][CAISSE_RAMASSEE]=0;

					NbCaisse++;
					if (NbCaisse>=MUR_MAX-1) 
						NbCaisse=MUR_MAX-1;
				}
			}
		}

		else 
			Balise=ObtenirBalise(Texte,i,Taille);
		
		if (BaliseTmp!=BALISE_AUCUNE)
			Balise=BaliseTmp;			
	}
	
	if (Charge)
		MapChargee=1;
	return ERREUR_AUCUNE;
}

// Chargement des textures:
int map::InitialisationTextures(int NumMap)
{
	char ListeDesNoms[LISTE_NOMBRE_MAX][LISTE_NOM_TAILLE_MAX];
	int NombreDeNoms;
	int Erreur=-1;
	int i=0;

	printf("Listage des textures...\n");
	Erreur=Lister(TEXTURE_NOM_FICHIER,(char*) ListeDesNoms, &NombreDeNoms);
	if (Erreur==ERREUR_AUCUNE)
	{	
		if (NumMap>=NombreDeNoms)
			NumMap=0;
		Erreur=Lister(ListeDesNoms[NumMap],(char*) ListeDesNomsDeTextures, &NombreDeTextures);

		if (Erreur==ERREUR_AUCUNE)
		{
			for (i=0;i<NombreDeTextures;i++)
			{	
				if(strcmp(TEXTURE_AUCUNE,ListeDesNomsDeTextures[i]))
				{
					printf("%s\n",ListeDesNomsDeTextures[i]);
					ListeDesTextures[i]=loadTexture(ListeDesNomsDeTextures[i] , 1);
					if (ListeDesTextures[i]==0)
						printf("Impossible de charger la texture \"%s\"\n", ListeDesNomsDeTextures[i]);
				}
			}
		}
	}
	return Erreur;
}

// Mise  0 des Parametre
void map::InitialisationMap()
{
	MapChargee=0;
	NbPlafon=0;
	NbMur=0;
	NbApparition=0;
	NbTeleporteur=0;
	NbPorte=0;
	NbCaisse=0;
}

// Dessin de la map
void map::Dessin()
{
	if (!MapChargee)
		return;

	DessinerLesPlafons();
	DessinerLesMurs();
	DessinerLesTeleporteurs();
	DessinerLesPortes();
	DessinerLesCaisses();
}

// Dessin des plafons
void map::DessinerLesPlafons()
{
	double x,y;
	int i;

	for (i=0;i<NbPlafon;i++)
	{
		x=Absolue((Plafon[i][PLAFON_X2]-Plafon[i][PLAFON_X1]))/Plafon[i][MUR_TEXTURE_REPETITION];
		y=Absolue((Plafon[i][PLAFON_Y2]-Plafon[i][PLAFON_Y1]))/Plafon[i][MUR_TEXTURE_REPETITION];

		glBindTexture(GL_TEXTURE_2D, ListeDesTextures[Plafon[i][PLAFON_TEXTURE]]);
		glBegin(GL_QUADS);
			glTexCoord2d(0,0);	glVertex3i(Plafon[i][PLAFON_X1]*UNITE, Plafon[i][PLAFON_Y1]*UNITE, Plafon[i][PLAFON_HAUTEUR]*UNITE);
			glTexCoord2d(x,0);	glVertex3i(Plafon[i][PLAFON_X2]*UNITE, Plafon[i][PLAFON_Y1]*UNITE, Plafon[i][PLAFON_HAUTEUR]*UNITE);
			glTexCoord2d(x,y);	glVertex3i(Plafon[i][PLAFON_X2]*UNITE, Plafon[i][PLAFON_Y2]*UNITE, Plafon[i][PLAFON_HAUTEUR]*UNITE);
			glTexCoord2d(0,y);	glVertex3i(Plafon[i][PLAFON_X1]*UNITE, Plafon[i][PLAFON_Y2]*UNITE, Plafon[i][PLAFON_HAUTEUR]*UNITE);
		glEnd();
	}
}

// Dessin des teleporteurs
void map::DessinerLesTeleporteurs()
{
	int i,xy,z;

	for (i=0;i<NbTeleporteur;i++)
	{
		xy=1;
		z =1;

		glBindTexture(GL_TEXTURE_2D, ListeDesTextures[Teleporteur[i][MUR_TEXTURE]]);
		glBegin(GL_QUADS);
		if (char(Teleporteur[i][TELEPORTEUR_SENS])=='h')
		{
			glTexCoord2d(0 ,0);	glVertex3d( (Teleporteur[i][TELEPORTEUR_POS_X]+TELEPORTEUR_LARGEUR*2)*UNITE, Teleporteur[i][TELEPORTEUR_POS_Y]*UNITE, 0);
			glTexCoord2d(xy,0);	glVertex3d( (Teleporteur[i][TELEPORTEUR_POS_X]					)*UNITE, Teleporteur[i][TELEPORTEUR_POS_Y]*UNITE, 0);
			glTexCoord2d(xy,z);	glVertex3d( (Teleporteur[i][TELEPORTEUR_POS_X]					)*UNITE, Teleporteur[i][TELEPORTEUR_POS_Y]*UNITE, TELEPORTEUR_HAUTEUR*UNITE);
			glTexCoord2d(0 ,z);	glVertex3d( (Teleporteur[i][TELEPORTEUR_POS_X]+TELEPORTEUR_LARGEUR*2)*UNITE, Teleporteur[i][TELEPORTEUR_POS_Y]*UNITE, TELEPORTEUR_HAUTEUR*UNITE);
		}
		else
		{
			glTexCoord2d(0 ,0);	glVertex3d( Teleporteur[i][TELEPORTEUR_POS_X]*UNITE, (Teleporteur[i][TELEPORTEUR_POS_Y]+2*TELEPORTEUR_LARGEUR	)*UNITE, 0);
			glTexCoord2d(xy,0);	glVertex3d( Teleporteur[i][TELEPORTEUR_POS_X]*UNITE, (Teleporteur[i][TELEPORTEUR_POS_Y]						)*UNITE, 0);
			glTexCoord2d(xy,z);	glVertex3d( Teleporteur[i][TELEPORTEUR_POS_X]*UNITE, (Teleporteur[i][TELEPORTEUR_POS_Y]						)*UNITE, TELEPORTEUR_HAUTEUR*UNITE);
			glTexCoord2d(0 ,z);	glVertex3d( Teleporteur[i][TELEPORTEUR_POS_X]*UNITE, (Teleporteur[i][TELEPORTEUR_POS_Y]+2*TELEPORTEUR_LARGEUR	)*UNITE, TELEPORTEUR_HAUTEUR*UNITE);
		}
		glEnd();
	}
}

void map::DessinerLesMurs()
{
	double xy,z;
	int i;

	for (i=0;i<NbMur;i++)
	{
		xy=Absolue(Mur[i][MUR_XY_MAX]-Mur[i][MUR_XY_MIN])/Mur[i][MUR_TEXTURE_REPETITION];
		z =Absolue(Mur[i][MUR_Z_MAX] -Mur[i][MUR_Z_MIN])/Mur[i][MUR_TEXTURE_REPETITION];

		glBindTexture(GL_TEXTURE_2D, ListeDesTextures[Mur[i][MUR_TEXTURE]]);
		glBegin(GL_QUADS);
		if (char(Mur[i][MUR_TYPE])=='h')
		{
			glTexCoord2d(0 ,0);	glVertex3i(Mur[i][MUR_XY_MIN]*UNITE, Mur[i][MUR_XY_POS]*UNITE, Mur[i][MUR_Z_MIN]*UNITE);
			glTexCoord2d(xy,0);	glVertex3i(Mur[i][MUR_XY_MAX]*UNITE, Mur[i][MUR_XY_POS]*UNITE, Mur[i][MUR_Z_MIN]*UNITE);
			glTexCoord2d(xy,z);	glVertex3i(Mur[i][MUR_XY_MAX]*UNITE, Mur[i][MUR_XY_POS]*UNITE, Mur[i][MUR_Z_MAX]*UNITE);
			glTexCoord2d(0 ,z);	glVertex3i(Mur[i][MUR_XY_MIN]*UNITE, Mur[i][MUR_XY_POS]*UNITE, Mur[i][MUR_Z_MAX]*UNITE);
		}
		else
		{
			glTexCoord2d(0 ,0);	glVertex3i(Mur[i][MUR_XY_POS]*UNITE, Mur[i][MUR_XY_MIN]*UNITE, Mur[i][MUR_Z_MIN]*UNITE);
			glTexCoord2d(xy,0);	glVertex3i(Mur[i][MUR_XY_POS]*UNITE, Mur[i][MUR_XY_MAX]*UNITE, Mur[i][MUR_Z_MIN]*UNITE);
			glTexCoord2d(xy,z);	glVertex3i(Mur[i][MUR_XY_POS]*UNITE, Mur[i][MUR_XY_MAX]*UNITE, Mur[i][MUR_Z_MAX]*UNITE);
			glTexCoord2d(0 ,z);	glVertex3i(Mur[i][MUR_XY_POS]*UNITE, Mur[i][MUR_XY_MIN]*UNITE, Mur[i][MUR_Z_MAX]*UNITE);
		}
		glEnd();
	}
}

void map::DessinerLesCaisses()
{
	int i;

	for (i=0;i<NbCaisse;i++)
	{
		if (Caisse[i][CAISSE_RAMASSEE]==CAISSE_EST_NON_RAMASSEE)
			DessinePave((Caisse[i][CAISSE_POS_X]+CAISSE_DECALAGE-CAISSE_TAILLE)*UNITE,
						(Caisse[i][CAISSE_POS_Y]+CAISSE_DECALAGE-CAISSE_TAILLE)*UNITE,
						0,
						(Caisse[i][CAISSE_POS_X]+CAISSE_DECALAGE+CAISSE_TAILLE)*UNITE,
						(Caisse[i][CAISSE_POS_Y]+CAISSE_DECALAGE+CAISSE_TAILLE)*UNITE,
						CAISSE_TAILLE*2*UNITE,
						1,
						1,
						ListeDesTextures[Caisse[i][CAISSE_TEXTURE]]		);		
	}
}

// Pour dessiner les portes
void map::DessinerLesPortes()
{
	int i,xy;
	double z;

	for (i=0;i<NbPorte;i++)
	{
		xy=1;
		z=1-double(Porte[i][PORTE_HAUTEUR_VAR])/(Porte[i][PORTE_Z_MAX]-Porte[i][PORTE_Z_MIN])/UNITE;

		glBindTexture(GL_TEXTURE_2D, ListeDesTextures[Porte[i][PORTE_TEXTURE]]);
		glBegin(GL_QUADS);
		if (char(Porte[i][PORTE_TYPE])=='h')
		{
			glTexCoord2d(0 ,0);	glVertex3i(Porte[i][PORTE_XY_MIN]*UNITE, Porte[i][PORTE_XY_POS]*UNITE, (Porte[i][PORTE_Z_MIN]*UNITE+Porte[i][PORTE_HAUTEUR_VAR]));
			glTexCoord2d(xy,0);	glVertex3i(Porte[i][PORTE_XY_MAX]*UNITE, Porte[i][PORTE_XY_POS]*UNITE, (Porte[i][PORTE_Z_MIN]*UNITE+Porte[i][PORTE_HAUTEUR_VAR]));
			glTexCoord2d(xy,z);	glVertex3i(Porte[i][PORTE_XY_MAX]*UNITE, Porte[i][PORTE_XY_POS]*UNITE, Porte[i][PORTE_Z_MAX]*UNITE);
			glTexCoord2d(0 ,z);	glVertex3i(Porte[i][PORTE_XY_MIN]*UNITE, Porte[i][PORTE_XY_POS]*UNITE, Porte[i][PORTE_Z_MAX]*UNITE);
		}
		else
		{
			glTexCoord2d(0 ,0);	glVertex3i(Porte[i][PORTE_XY_POS]*UNITE, Porte[i][PORTE_XY_MIN]*UNITE, (Porte[i][PORTE_Z_MIN]*UNITE+Porte[i][PORTE_HAUTEUR_VAR]));
			glTexCoord2d(xy,0);	glVertex3i(Porte[i][PORTE_XY_POS]*UNITE, Porte[i][PORTE_XY_MAX]*UNITE, (Porte[i][PORTE_Z_MIN]*UNITE+Porte[i][PORTE_HAUTEUR_VAR]));
			glTexCoord2d(xy,z);	glVertex3i(Porte[i][PORTE_XY_POS]*UNITE, Porte[i][PORTE_XY_MAX]*UNITE, Porte[i][PORTE_Z_MAX]*UNITE);
			glTexCoord2d(0 ,z);	glVertex3i(Porte[i][PORTE_XY_POS]*UNITE, Porte[i][PORTE_XY_MIN]*UNITE, Porte[i][PORTE_Z_MAX]*UNITE);
		}
		glEnd();
	}
}

// Obtenir des coord d'apparition
void map::ObtenirApparition(POINT *apparition)
{
	if (NbApparition==0)
	{
		apparition->x=APPARITION_DEFAUT_X;
		apparition->y=APPARITION_DEFAUT_Y;
		return;
	}

	int N=(int)Random(NbApparition);

	apparition->x=Apparition[N][APPARITION_X];
	apparition->y=Apparition[N][APPARITION_Y];
}

// Ramassage des caisses:
int map::CalculRamassageCaisse(double X,double Y,double &Vie,int Duree)
{
	int C=-1;
	int i,x,y,RayC;	
	RayC=int( (CAISSE_TAILLE)*(CAISSE_TAILLE)*2*UNITE*UNITE);

	for (i=0;i<NbCaisse;i++)
	{
		x=int((Caisse[i][CAISSE_POS_X]+CAISSE_DECALAGE)*UNITE-X);
		y=int((Caisse[i][CAISSE_POS_Y]+CAISSE_DECALAGE)*UNITE-Y);
		if (Caisse[i][CAISSE_RAMASSEE]==CAISSE_EST_NON_RAMASSEE)
		{
			if (x*x+y*y<RayC)
			{				
				if (Vie<VIE_MAX)
				{
					Caisse[i][CAISSE_RAMASSEE]=CAISSE_EST_RAMASSEE;
					Caisse[i][CAISSE_TEMPS_RESTANT]=CAISSE_TEMPS_REAPARITION;
					Vie+=CAISSE_VIE;
					C=i;
				}

				if (Vie>VIE_MAX)
					Vie=VIE_MAX;

			}
		}
		else
		{
			Caisse[i][CAISSE_TEMPS_RESTANT]-=Duree;
			if (Caisse[i][CAISSE_TEMPS_RESTANT]<0)
				Caisse[i][CAISSE_RAMASSEE]=CAISSE_EST_NON_RAMASSEE;
		}
	}
	return C;
}		

void map::RamasseCaisse(int N)
{
	if ((N<NbCaisse)&&(N>=0))
	{
		Caisse[N][CAISSE_RAMASSEE]=CAISSE_EST_RAMASSEE;
		Caisse[N][CAISSE_TEMPS_RESTANT]=CAISSE_TEMPS_REAPARITION;
	}
}
// Ouverture des portes:
int map::CalculOuverturePorte(int N,double *X,double *Y,int msPasse)
{
	bool PFerme=0;
	bool POuvre=0;
	int i,j,x,y,RayC;
	double x2,y2;
	bool Ouvre=false;
	int Precedant;	// Pour savoir si la porte a chang d'tat

	for (i=0;i<NbPorte;i++)
	{
		Ouvre=false;
		Precedant=Porte[i][PORTE_PRECEDANT];
		if (Porte[i][PORTE_TYPE]=='h')
		{
			x=(Porte[i][PORTE_XY_MIN]+Porte[i][PORTE_XY_MAX])/2; // On fait la moyenne pour savoir ou se trouve le centre de la porte
			y=Porte[i][PORTE_XY_POS];
		}
		else
		{
			y=(Porte[i][PORTE_XY_MIN]+Porte[i][PORTE_XY_MAX])/2; // On fait la moyenne pour savoir ou se trouve le centre de la porte
			x=Porte[i][PORTE_XY_POS];
		}

		RayC=((Porte[i][PORTE_XY_MAX]-Porte[i][PORTE_XY_MIN])*UNITE)*((Porte[i][PORTE_XY_MAX]-Porte[i][PORTE_XY_MIN])*UNITE); // On calcul le carre du rayon du cercle  l'intrieur duquel la porte s'ouvre 
		if	(RayC<4*UNITE*UNITE)
			RayC=4*UNITE*UNITE;

		for (j=0;j<N;j++)
		{			
			x2=X[j]-x*UNITE;
			y2=Y[j]-y*UNITE;
			if (( x2*x2+y2*y2 )<RayC)
			{
				Ouvre=true;
			}
		}
		if (Ouvre)
		{
			Porte[i][PORTE_PRECEDANT]=PORTE_OUVRE;
			Porte[i][PORTE_HAUTEUR_VAR]+=int(PORTE_VITESSE*UNITE*msPasse);	
		}
		else 
		{
			Porte[i][PORTE_PRECEDANT]=PORTE_FERME;
			Porte[i][PORTE_HAUTEUR_VAR]-=int(PORTE_VITESSE*UNITE*msPasse);
		}

		if (Porte[i][PORTE_HAUTEUR_VAR]<0)
		{
			Porte[i][PORTE_PRECEDANT]=PORTE_RIEN;
			Porte[i][PORTE_HAUTEUR_VAR]=0;
		}

		if (Porte[i][PORTE_HAUTEUR_VAR]>(Porte[i][PORTE_Z_MAX]*(1-PORTE_OUVERTURE_MAX)*UNITE))
		{
			Porte[i][PORTE_PRECEDANT]=PORTE_RIEN;
			Porte[i][PORTE_HAUTEUR_VAR]=int((double)Porte[i][PORTE_Z_MAX]*(1-PORTE_OUVERTURE_MAX)*UNITE);
		}

		if (Porte[i][PORTE_PRECEDANT]!=Precedant)
		{
			x2=X[0]-x*UNITE;
			y2=Y[0]-y*UNITE;
			if (( x2*x2+y2*y2 )<DISTANCE_ECOUTE_PORTE_MINIMUM)
			{
				return Porte[i][PORTE_PRECEDANT];
			}
		}			
	}

	if (PFerme)
	{
		return PORTE_FERME;
	}
	if (POuvre)
	{
		return PORTE_OUVRE;
	}
	return PORTE_RIEN;
}

// Colision des balles ac le mur:
void map::CalculColisionBalle(balle *Balle,double &Vx,double &Vy,double &Vz)
{
	int i;
	double Vyt,Vzt,Vxt;
	for (i=0;i<NbMur;i++)
	{		
		if (Mur[i][MUR_TYPE]=='h')
		{
			if ((Balle->Y-Mur[i][MUR_XY_POS]*UNITE>0)!=(Balle->Y-Mur[i][MUR_XY_POS]*UNITE+Vy>0))
			{				
				Vyt=Mur[i][MUR_XY_POS]*UNITE-Balle->Y;
				Vxt=Vx*Vyt/Vy;
				if ((Balle->X+Vxt<Mur[i][MUR_XY_MAX]*UNITE)&&(Balle->X+Vxt>Mur[i][MUR_XY_MIN]*UNITE))
				{				
					Vzt=Vz*Vyt/Vy;
					if ((Balle->Z+Vzt<Mur[i][MUR_Z_MAX]*UNITE)&&(Balle->Z+Vzt>Mur[i][MUR_Z_MIN]*UNITE))
					{						
						Vx=Vxt;
						Vz=Vzt;
						Vy=Vyt;
						Balle->ASupprimer=1;
					}
				}
			}
		}
		else
		{
			if ((Balle->X-Mur[i][MUR_XY_POS]*UNITE>0)!=(Balle->X-Mur[i][MUR_XY_POS]*UNITE+Vx>0))
			{
				Vxt=Mur[i][MUR_XY_POS]*UNITE-Balle->X;
				Vyt=Vy*Vxt/Vx;
				if ((Balle->Y+Vyt<Mur[i][MUR_XY_MAX]*UNITE)&&(Balle->Y+Vyt>Mur[i][MUR_XY_MIN]*UNITE))
				{
					Vzt=Vz*Vxt/Vx;
					if ((Balle->Z+Vzt<Mur[i][MUR_Z_MAX]*UNITE)&&(Balle->Z+Vzt>Mur[i][MUR_Z_MIN]*UNITE))
					{
						Vx=Vxt;
						Vz=Vzt;
						Vy=Vyt;
						Balle->ASupprimer=1;
					}
				}
			}
		}
	}
}
			


// Colision des perso avec les murs:
void map::CalculColision(double &X, double &Y, double PosX, double PosY)
{
	int i;
	for (i=0;i<NbMur;i++)
	{
		if ((Mur[i][MUR_Z_MAX]==0)||(Mur[i][MUR_Z_MIN]==0)||(Mur[i][MUR_Z_MAX]==1)||(Mur[i][MUR_Z_MIN]==1))
		{
			if (Mur[i][MUR_TYPE]=='h')
			{
				if ( ( (PosX<(Mur[i][MUR_XY_MAX]+MUR_DISTANCE_MIN)*UNITE)&&(PosX>(Mur[i][MUR_XY_MIN]-MUR_DISTANCE_MIN)*UNITE ) ) || ( (PosX>(Mur[i][MUR_XY_MAX]-MUR_DISTANCE_MIN)*UNITE)&&(PosX<(Mur[i][MUR_XY_MIN]+MUR_DISTANCE_MIN)*UNITE ) ) )
				{
					if (PosY>Mur[i][MUR_XY_POS]*UNITE)
					{
						if ((Y<0)&&( SigneDe(PosY-MUR_DISTANCE_MIN*UNITE-Mur[i][MUR_XY_POS]*UNITE)!=SigneDe(PosY-MUR_DISTANCE_MIN*UNITE+Y-Mur[i][MUR_XY_POS]*UNITE) ))
						{
							Y=0;
						}
					}
					else
					{
						if ((Y>0)&&( SigneDe(PosY+MUR_DISTANCE_MIN*UNITE-Mur[i][MUR_XY_POS]*UNITE)!=SigneDe(PosY+MUR_DISTANCE_MIN*UNITE+Y-Mur[i][MUR_XY_POS]*UNITE) ))
						{
							Y=0;
						}
					}
				}
				if ( ( PosY<= (Mur[i][MUR_XY_POS]+MUR_DISTANCE_MIN)*UNITE ) && ( PosY >= (Mur[i][MUR_XY_POS]-MUR_DISTANCE_MIN)*UNITE ) ) // Pour le coin des murs
				{
					if ( (PosX<(Mur[i][MUR_XY_MAX]+MUR_DISTANCE_MIN)*UNITE )&&(PosX>Mur[i][MUR_XY_MIN]*UNITE) )
					{
						if (X<0)
							X=0;
					}
					if ( (PosX>(Mur[i][MUR_XY_MIN]-MUR_DISTANCE_MIN)*UNITE )&&(PosX<Mur[i][MUR_XY_MIN]*UNITE) )
					{
						if (X>0)
							X=0;
					}
				}
			}
			else
			{
				if ( ( (PosY<(Mur[i][MUR_XY_MAX]+MUR_DISTANCE_MIN)*UNITE)&&(PosY>(Mur[i][MUR_XY_MIN]-MUR_DISTANCE_MIN)*UNITE ) ) || ( (PosY>(Mur[i][MUR_XY_MAX]-MUR_DISTANCE_MIN)*UNITE)&&(PosY<(Mur[i][MUR_XY_MIN]+MUR_DISTANCE_MIN)*UNITE ) ) )
				{
					if (PosX>Mur[i][MUR_XY_POS]*UNITE)
					{
						if ( (X<0)&&( SigneDe(PosX-MUR_DISTANCE_MIN*UNITE-Mur[i][MUR_XY_POS]*UNITE)!=SigneDe(PosX-MUR_DISTANCE_MIN*UNITE+X-Mur[i][MUR_XY_POS]*UNITE) ))
						{
							X=0;
						}
					}
					else
					{
						if ((X>0)&&( SigneDe(PosX+MUR_DISTANCE_MIN*UNITE-Mur[i][MUR_XY_POS]*UNITE)!=SigneDe(PosX+MUR_DISTANCE_MIN*UNITE+X-Mur[i][MUR_XY_POS]*UNITE) ))
						{
							X=0;
						}
					}
				}
				if ( ( PosX<= (Mur[i][MUR_XY_POS]+MUR_DISTANCE_MIN)*UNITE ) && ( PosX >= (Mur[i][MUR_XY_POS]-MUR_DISTANCE_MIN)*UNITE ) ) // Pour le coin des murs
				{
					if ( (PosY<(Mur[i][MUR_XY_MAX]+MUR_DISTANCE_MIN)*UNITE )&&(PosY>Mur[i][MUR_XY_MIN]*UNITE) )
					{
						if (Y<0)
							Y=0;
					}
					if ( (PosY>(Mur[i][MUR_XY_MIN]-MUR_DISTANCE_MIN)*UNITE )&&(PosY<Mur[i][MUR_XY_MIN]*UNITE) )
					{
						if (Y>0)
							Y=0;
					}
				}
			}
		}
	}	
}

bool map::CalculTeleporteur(double &X, double &Y, double &PosX, double &PosY, double &Angle)
{
	int i;
	bool T=0;
	for (i=0;i<NbTeleporteur;i++)
	{
		if ((char)Teleporteur[i][TELEPORTEUR_SENS]=='h')
		{
			if ((PosX<(Teleporteur[i][TELEPORTEUR_POS_X]+2*TELEPORTEUR_LARGEUR)*UNITE)&&(PosX>(Teleporteur[i][TELEPORTEUR_POS_X])*UNITE))
			{			
				if (SigneDe(PosY-Teleporteur[i][TELEPORTEUR_POS_Y]*UNITE)!=SigneDe(PosY+Y-Teleporteur[i][TELEPORTEUR_POS_Y]*UNITE) )
				{
					X=0;
					Y=0;
					PosX=(Teleporteur[i][TELEPORTEUR_D_X]+0.5)*UNITE;
					PosY=(Teleporteur[i][TELEPORTEUR_D_Y]+0.5)*UNITE;
					Angle=Teleporteur[i][TELEPORTEUR_ANGLE];
					T=1;
				}
			}
		}
		else
		{
			if ((PosY<(Teleporteur[i][TELEPORTEUR_POS_Y]+2*TELEPORTEUR_LARGEUR)*UNITE)&&(PosY>(Teleporteur[i][TELEPORTEUR_POS_Y])*UNITE))
			{			
				if (SigneDe(PosX-Teleporteur[i][TELEPORTEUR_POS_X]*UNITE)!=SigneDe(PosX+X-Teleporteur[i][TELEPORTEUR_POS_X]*UNITE) )
				{
					X=0;
					Y=0;
					PosX=(Teleporteur[i][TELEPORTEUR_D_X]+0.5)*UNITE;
					PosY=(Teleporteur[i][TELEPORTEUR_D_Y]+0.5)*UNITE;
					Angle=Teleporteur[i][TELEPORTEUR_ANGLE];
					T=1;
				}
			}
		}
	}
	return T;
}
