#include "option.h"

////////////////
// Fonctions: //
////////////////

// Charge un int dans un fichier:
int ChargeInt(HANDLE Fichier,int *Variable)
{
	unsigned long NbLu;
	ReadFile(Fichier,Variable,sizeof(int),&NbLu,NULL);
	if (NbLu!=sizeof(int))
	{
		printf("Erreur: fin du fichier inatendue\n");
		return ERREUR_ERREUR;
	}
	return ERREUR_AUCUNE;
}

// Enregistre un int dans un fichier:
int EnregistreInt(HANDLE Fichier,int Variable)
{
	unsigned long NbEcrit;
	WriteFile(Fichier,&Variable,sizeof(int),&NbEcrit,NULL);
	if (NbEcrit!=sizeof(int))
	{
		printf("Erreur: Impossible d'ecrire dans le fichier options\n");
		return ERREUR_ERREUR;
	}
	return ERREUR_AUCUNE;
}

// Charge les options depuis le fichier:
int options::ChargeOptions()
{
	int Erreur;
	HANDLE Fichier;
	printf("Chargement des options\n");

	Fichier=CreateFile(OPTIONS_FICHIER_NOM,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,NULL,NULL);
	if (Fichier!=INVALID_HANDLE_VALUE)
	{
		Erreur=ChargeInt(Fichier,&LargeurFenetre);
		if (Erreur!=ERREUR_ERREUR)
			Erreur=ChargeInt(Fichier,&HauteurFenetre);
		if (Erreur!=ERREUR_ERREUR)
			Erreur=ChargeInt(Fichier,&FpsMax);
		if (Erreur!=ERREUR_ERREUR)
			Erreur=ChargeInt(Fichier,&Visibilite);
		if (Erreur!=ERREUR_ERREUR)
			Erreur=ChargeInt(Fichier,&Brouillard);
		if (Erreur!=ERREUR_ERREUR)
			Erreur=ChargeInt(Fichier,&SensibiliteX);
		if (Erreur!=ERREUR_ERREUR)
			Erreur=ChargeInt(Fichier,&SensibiliteY);
		if (Erreur!=ERREUR_ERREUR)
			Erreur=ChargeInt(Fichier,&Couleur);	
		if (Erreur!=ERREUR_ERREUR)
			Erreur=ChargeInt(Fichier,&SonPorte);
		if (Erreur!=ERREUR_ERREUR)
		{
			Erreur=ChargeInt(Fichier,&AmeliorationFluidite);	
			AmeliorationFluidite=1;
		}
		if (Erreur!=ERREUR_ERREUR)
		{
			unsigned long NbLu;
			ReadFile(Fichier,Pseudo,OPTIONS_PSEUDO_MAX,&NbLu,NULL);
			if (NbLu!=OPTIONS_PSEUDO_MAX)
			{
				printf("Erreur: fin de fichier inatendue\n");
				Erreur=ERREUR_ERREUR;
			}
		}

		CloseHandle(Fichier);
		if (Erreur==ERREUR_ERREUR)
		{
			printf("Erreur lors du chargement des options\n");
			Erreur=ChargeOptionsParDefaut();
		}
	}

	else
	{
		CloseHandle(Fichier);
		printf("Fichier option inexistant\n");
		Erreur=ChargeOptionsParDefaut();
	}
	
	return Erreur;
}

int options::ChargeOptionsParDefaut()
{
	printf("Chargement des options par defaut\n");		
		
	LargeurFenetre=OPTIONS_DEFAUT_FENETRE_LARGEUR;
	HauteurFenetre=OPTIONS_DEFAUT_FENETRE_HAUTEUR;
	FpsMax=OPTIONS_DEFAUT_FENETRE_FPS_MAX;
	Visibilite=OPTIONS_DEFAUT_VISIBILITE;

	Brouillard=OPTIONS_DEFAUT_BROUILLARD;
	SensibiliteX=OPTIONS_DEFAUT_SENSIBILITE_X;
	SensibiliteY=OPTIONS_DEFAUT_SENSIBILITE_Y;
	
	Couleur=OPTIONS_DEFAUT_COULEUR;

	SonPorte=0;
	AmeliorationFluidite=1;

	strcpy(Pseudo,OPTIONS_DEFAUT_PSEUDO);

	printf("Creation d'un nouveau fichier option\n");
	return EnregistreOptions();
}

int options::EnregistreOptions()
{
	HANDLE Fichier;
	Fichier=CreateFile(OPTIONS_FICHIER_NOM,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,NULL,NULL);
	if (Fichier==INVALID_HANDLE_VALUE)
	{
		printf("Erreur: impossible d'enregistrer les options\n");
		return ERREUR_ERREUR;
	}
	EnregistreInt(Fichier,LargeurFenetre);	
	EnregistreInt(Fichier,HauteurFenetre);
	EnregistreInt(Fichier,FpsMax);
	EnregistreInt(Fichier,Visibilite);
	EnregistreInt(Fichier,Brouillard);
	EnregistreInt(Fichier,SensibiliteX);
	EnregistreInt(Fichier,SensibiliteY);
	EnregistreInt(Fichier,Couleur);	
	EnregistreInt(Fichier,SonPorte);
	EnregistreInt(Fichier,AmeliorationFluidite);	
	unsigned long NbEcrit;
	WriteFile(Fichier,Pseudo,OPTIONS_PSEUDO_MAX,&NbEcrit,NULL);
	if (NbEcrit!=OPTIONS_PSEUDO_MAX)
	{
		printf("Erreur: impossible d'crire dans le fichier option\n");		
	}

	CloseHandle(Fichier);
	return ERREUR_AUCUNE;
}

int options::ModifieOptions()
{
	printf("Entrez la largeur de la fenetre (defaut=%d):",OPTIONS_DEFAUT_FENETRE_LARGEUR);
	scanf("%d",&LargeurFenetre);

	printf("Entrez la hauteur de la fenetre (defaut=%d):",OPTIONS_DEFAUT_FENETRE_HAUTEUR);
	scanf("%d",&HauteurFenetre);

	printf("Entrez le nombre d'images par secondes maximum (defaut=%d):",OPTIONS_DEFAUT_FENETRE_FPS_MAX);
	scanf("%d",&FpsMax);

	printf("Entrez la visibilite (defaut=%d):",OPTIONS_DEFAUT_VISIBILITE);
	scanf("%d",&Visibilite);

	printf("Brouillard? (1=active 0=desactive):");
	scanf("%d",&Brouillard);

	printf("Entrez la sensibilite verticale(defaut=%d):",OPTIONS_DEFAUT_SENSIBILITE_X);
	scanf("%d",&SensibiliteX);

	printf("Entrez la sensibilite horizontale(defaut=%d):",OPTIONS_DEFAUT_SENSIBILITE_Y);
	scanf("%d",&SensibiliteY);

	printf("Entrez la couleur de votre perso,\n(noir=0,rouge=1,bleu=2,vert=3,jaune=4,orange=5,violet=6,turquoise=7):");
	scanf("%d",&Couleur);

	printf("Voulez vous jouer le son des porte qui s'ouvre et qui se ferme?(1=active,0=desactive):");
	scanf("%d",&SonPorte);

	/*printf("Voulez-vous activer l'amelioration de la fluidite: augmente la fluidite mais augmente le decalage?(1=active,0=desactive):");
	scanf("%d",&AmeliorationFluidite);*/

	printf("Entrez votre pseudo:");
	scanf("%s",Pseudo);
	Pseudo[OPTIONS_PSEUDO_MAX-1]='0';

	printf("Les chargements prendrons effet au prochain redemarage\n");
	printf("Enregistrement des options\n");

	return EnregistreOptions();
}





