#ifndef __EKAUQM_PERSO__
#define __EKAUQM_PERSO__

#include "includes.h"
#include "constantes.h"
#include "sdlglutils.h"
#include "temps.h"

////////////////////////////////
// Definitions de constantes: //
////////////////////////////////

#define PERSO_TYPE_SOI			0
#define PERSO_TYPE_AUTRE		1
#define PERSO_TYPE_INUTILISE	2
#define PSEUDO_TAILLE_MAX		100
#define PERSO_LARGEUR_TIR_CARRE	0.09 // Le diametre du tir

#define VIE_MAX					100
#define VIE_INITIALISATION		0.75
#define VIE_DEGAT				0.1

// joueurs
#define JOUEUR_TEXTURE_NB	2
#define JOUEUR_TEXTURE_J1	"donnees\\joueur\\j1.jpg"
#define JOUEUR_TEXTURE_J2	"donnees\\joueur\\j2.jpg"
#define JOUEUR_HAUTEUR		0.1 // relative  la taille
#define JOUEUR_HAUTEUR_MAX	0.5
#define JOUEUR_TAILLE		2.4

////////////////////////////////
// Definitions de structures: //
////////////////////////////////

struct perso
{
	double Vie;
	double AngleV;
	double Angle;
	double AngleP;
	double X;
	double Y;
	double Mal;
	int Couleur;
	int Score;
	char Date[50];
	char Pseudo[PSEUDO_TAILLE_MAX];
	int ID;
	int Type;
	int Duree;
	bool Touches[4];
	bool Mort;

	bool Action();
};

#endif