#include "position.h"

////////////////
// Fonctions: //
////////////////

void gestionposition::Initialisation()
{
	int i=0;
	ConteurPositionTotal=0;
	Attente=PERIODE_REMISE;
	for (i=0;i<CLIENT_MAX+1;i++)
	{
		Decalage[i]=-100000000;
		Action[i]=0;
		ConteurPosition[i]=0;
	}
}

// Pour ajouter une position depuis fenetre
void gestionposition::AjouterPositionBis(int ms,int ID,double X,double Y,double Angle,double AngleV,bool* Touches)
{
	if ((ID>CLIENT_MAX)||(ID<0))
		return;
	
	int a;

	a=Decalage[ID]+ms-SDL_GetTicks();

	//printf("a=%d\n",a);
	if ((a  <0)||(a>SEUIL_DECALAGE)) // Si l'attente est ngative
	{			
		Decalage[ID]=SDL_GetTicks()-ms;		// On met  jour le dcalage
	}
	
	AjouterPosition(Decalage[ID]+ms-SDL_GetTicks(),ID,X,Y,Angle,AngleV,Touches);
}

// Pour ajouter une position depuis AjouterPositionBis
void gestionposition::AjouterPosition(int ms,int ID,double X,double Y,double Angle,double AngleV,bool* Touches)
{
	int i=0;

	if ((ID<0)||(ID>CLIENT_MAX))
		return;

	Positions[ID][ConteurPosition[ID]].TpsRestant=ms;
	Positions[ID][ConteurPosition[ID]].X=X;
	Positions[ID][ConteurPosition[ID]].Y=Y;
	Positions[ID][ConteurPosition[ID]].Angle=Angle;
	Positions[ID][ConteurPosition[ID]].AngleV=AngleV;
	Positions[ID][ConteurPosition[ID]].Conteur=ConteurPositionTotal;
	for (i=0;i<4;i++)
		Positions[ID][ConteurPosition[ID]].Touches[i]=Touches[i];

	ConteurPositionTotal++;
	ConteurPosition[ID]++;
	if (ConteurPosition[ID]>=POSITION_MAX-1)
		ConteurPosition[ID]=0;
}

// Pour obtenir une position depuis fenetre (deplacement)
void gestionposition::ObtenirPosition(perso	*Perso)
{
	int i=0;
	int LaBonne=-1;
	int NumDeLaBonne=-1;
	if ((Perso->Type!=PERSO_TYPE_AUTRE)||(Perso->ID<0)||(Perso->ID>CLIENT_MAX))
		return;

	for (i=0;i<POSITION_MAX;i++)	// On cherche la position ac tps restant infrieur  0 ac le plus grand Conteur
	{
		if (Positions[Perso->ID][i].TpsRestant<=0)
		{
			Positions[Perso->ID][i].TpsRestant=10000000; // on met un grand temps pour quelle soit execut qu'une seule fois 
			if (Positions[Perso->ID][i].Conteur>NumDeLaBonne)
			{
				LaBonne=i;
				NumDeLaBonne=Positions[Perso->ID][i].Conteur;
			}
		}
	}

	if (NumDeLaBonne!=-1) // Si on en a trouv une
	{
		// On la copie
		Perso->X=Positions[Perso->ID][LaBonne].X;
		Perso->Y=Positions[Perso->ID][LaBonne].Y;
		Perso->Angle=Positions[Perso->ID][LaBonne].Angle;
		Perso->AngleV=Positions[Perso->ID][LaBonne].AngleV;

		for (i=0;i<4;i++)
		{
			Perso->Touches[i]=Positions[Perso->ID][LaBonne].Touches[i];
		}		
	}
}

void gestionposition::MiseAjourPosition(int msPassees)
{
	int i=0,j=0;
	for (i=0;i<CLIENT_MAX+1;i++)
	{
		for (j=0;j<POSITION_MAX;j++)
		{
			Positions[i][j].TpsRestant-=msPassees;			
		}
	} 
	Attente-=msPassees;
	if (Attente<0)
	{
		Attente=PERIODE_REMISE;
		for (i=0;i<CLIENT_MAX+1;i++)
		{
			Decalage[i]=-100000000;
		}
	}
}

