#include "reseau.h"

///////////////
// Variables //
///////////////

destinataire DClient[CLIENT_MAX];		// Les 7 clients
ParametreRecevoir PClient[CLIENT_MAX];	// Ainsi que les parametres pour les fonctions recevoir
destinataire DServeur;					// Le serveur
ParametreRecevoir PServeur;				// Ainsi que les ...
CRITICAL_SECTION Ajouter;				// Pour qu'on ajoute qu'un message  la fois
CRITICAL_SECTION AjouterBis;
CRITICAL_SECTION Verif;					// L'endroit ou on incrmente le vrificateur
CRITICAL_SECTION Envoyer;
CRITICAL_SECTION EnvoyerBis;
ParametreAttenteConnection PAttente;	// Nos parametres
reseau *PointeurReseau;					// Pointeur sur notre classe rseau

// Simulation d'un ping lev:
#define SIMULATION_PING				0	// =ping/2
#define SIMULATION_ALEATOIRE		70	// % d'alatoire dans la simulation
#define SIMULATION_MAX				50
MessageEnvoie	SimulationMessage[SIMULATION_MAX];
long unsigned	SimulationThreadId[SIMULATION_MAX];
int				SimulationNDest[SIMULATION_MAX];

////////////////
// Fonctions: //
////////////////

#if (SIMULATION_PING>0)

DWORD WINAPI SimulationPing(void* Param)
{
	int Numero=*(int*)Param;	// Position dans le tableau o est stoqu notre message
	free(Param);			// On libre Param

	int i;

	for (i=0;i<Random2(50);i++);

	Sleep(SIMULATION_PING+Random(1)*SIMULATION_ALEATOIRE*SIMULATION_PING/100);	// Attente avant d'envoyer le message

	if ((SimulationNDest[Numero]<0)||(SimulationNDest[Numero]>=CLIENT_MAX)) // Si on peu pas envoyer au destinataire donn
	{	
		PointeurReseau->EnvoyerMessage(SimulationMessage[Numero]);			// On envoie  tt le monde
	}
	else								// sinon
		PointeurReseau->EnvoyerMessageA(SimulationMessage[Numero],SimulationNDest[Numero]);		// On lui envoie
	
	return 0;
}

#endif


DWORD WINAPI Recevoir(void* Param)
{
	MessageEnvoie Msg;
	int LeVerificateur[2]={0,0};
	ParametreRecevoir *Parametres=(ParametreRecevoir*)Param;
	SetEvent(Parametres->Destinataire->Evenement);

	while (1)
	{
		recv(Parametres->Destinataire->Destinataire,(char*)&Msg,sizeof(MessageEnvoie),NULL);
		
		if (LeVerificateur[0]==Msg.UnVerificateur)
		{
			LeVerificateur[1]++;
			if (LeVerificateur[1]>RESEAU_VERIFICATEUR_MAX)
			{
				ResetEvent(Parametres->Destinataire->Evenement);
			
				if (Parametres->Reseau->Serveur)
					Parametres->Reseau->AjouterMessageBis(MESSAGE_DECONNECTION,Parametres->id,NULL);
				else
				{
					Parametres->Reseau->AjouterMessageBis(MESSAGE_HOTE_DECONNECTE,ID_SERVEUR,NULL);
				}				
				return 0;
			}			
		}
		else
		{
			LeVerificateur[1]=0;
			LeVerificateur[0]=Msg.UnVerificateur;
			Parametres->Reseau->AjouterMessage(Msg);
		}			
	}
	return 0;
}

DWORD WINAPI AttenteConnection(void* Param)
{
	int i=0,j=0;
	int TailleSin;
	SOCKADDR_IN Sin;
	SOCKET Socket;
	WSADATA WSAData;

	ParametreAttenteConnection *Parametres; // On charge les parametres
	Parametres=(ParametreAttenteConnection*)Param;

	WSAStartup(MAKEWORD(2,0), &WSAData);		
	Socket = socket(AF_INET, SOCK_STREAM, 0);
	Sin.sin_addr.s_addr			= INADDR_ANY;
	Sin.sin_family				= AF_INET;
	Sin.sin_port				= htons(Parametres->Port);
	if (bind(Socket, (SOCKADDR *)&Sin, sizeof(Sin))==SOCKET_ERROR)
	{
		printf("\nErreur: bind a echoue, le port est probablement deja utilise\n");
		return ERREUR_ERREUR;
	}

	listen(Socket, CLIENT_MAX);

	while (1)
	{	
		Sleep(1);

		while (WaitForSingleObject(DClient[i].Evenement,0)==WAIT_OBJECT_0) // On cherche une place pour notre client
		{
			i++; 
			if (i>=CLIENT_MAX)
				i=0;
		}
		TailleSin=sizeof(Sin);
		if(( DClient[i].Destinataire = accept(Socket, (SOCKADDR *)&Sin, &TailleSin)) != INVALID_SOCKET) // On accepte les connection
		{
			double Id[MESSAGE_PARAMETRE_MAX]={i};
			SetEvent(DClient[i].Evenement);
			Parametres->Reseau->EnvoyerMessageBis(MESSAGE_ID,ID_SERVEUR,Id,i);
			
			PClient[i].Destinataire=&DClient[i];
			PClient[i].Reseau=Parametres->Reseau;
			PClient[i].id=i;
			
			if (CreateThread(NULL,NULL,Recevoir,&PClient[i],NULL,&DClient[i].ThreadId)!=NULL) // On lance la fonction recevoir
				CloseHandle(Recevoir);
		}
	}
	return 0;
}


//////////////
// Classes: //
//////////////

int reseau::IncrementeVerificateur()
{
	EnterCriticalSection(&Verif);
	PourVerifier+=(int(Random(100))+1);
	LeaveCriticalSection(&Verif); 
	return PourVerifier;
}	

void reseau::AjouterMessage(MessageEnvoie Msg)
{	
	EnterCriticalSection(&Ajouter); // On ne peut executer ce code qu'une fois en mme temps

	int i=0;

	while (WaitForSingleObject(Message[i].Evenement,0)==WAIT_OBJECT_0) // On cherche un message ou l'venement n'est pas activ
	{
		i++;
		if (i>=MESSAGE_MAX)
			i=0;
	}

	Message[i].IDJoueur=Msg.IDJoueur;	// On copie les donnes
	Message[i].Message=Msg.Message;
	Message[i].Numero=ConteurMessage;
	memcpy(Message[i].Donnees,Msg.Donnees,sizeof(double)*MESSAGE_PARAMETRE_MAX);

	SetEvent(Message[i].Evenement);	// On active l'venement du message pour que 

	ConteurMessage++;				// On incrmente le conteur de messages pour que ces derniers soit lu dans l'ordre 

	LeaveCriticalSection(&Ajouter); // On a ajouter notre message on peut laisser les autre le faire
}

void reseau::AjouterMessageBis(int Mess,int ID,double* Donnees)
{
	EnterCriticalSection(&AjouterBis);
	MessageEnvoie Msg;
	Msg.Message=Mess;
	Msg.IDJoueur=ID;
	if (Donnees!=NULL)
		memcpy(Msg.Donnees,Donnees,sizeof(double)*MESSAGE_PARAMETRE_MAX);
	AjouterMessage(Msg);
	LeaveCriticalSection(&AjouterBis);			
}


int reseau::ObtenirMessage(message *Msg)
{
	int i;
	int min[2]={-1,0};
	for (i=0;i<MESSAGE_MAX;i++)
	{
		if (WaitForSingleObject(Message[i].Evenement,0)==WAIT_OBJECT_0) // On cherche un message dont l'venement est activ
		{
			if ((min[0]<0)||(min[0]>Message[i].Numero)) // On cherche celui qui  le plus petit Numero
			{
				min[0]=Message[i].Numero;
				min[1]=i;
			}			
		}
	}

	if (min[0]>=0) // si on  trouv un message on copie les donnes et on renvoie MESSAGE_ENCORE
	{
		memcpy(Msg->Donnees,Message[min[1]].Donnees,sizeof(double)*MESSAGE_PARAMETRE_MAX);
		Msg->IDJoueur=Message[min[1]].IDJoueur;
		Msg->Message=Message[min[1]].Message;
		Msg->Numero=Message[min[1]].Numero;

		ResetEvent(Message[min[1]].Evenement);
		return MESSAGE_ENCORE;
	}

	return MESSAGE_AUCUN; // sinon on renvoie MESSAGE_AUCUN
}

void reseau::EnvoyerMessage(MessageEnvoie Msg) 
{
	EnterCriticalSection(&Envoyer);
	int i;
	Msg.UnVerificateur=IncrementeVerificateur();

	if (!Serveur) // Si on est client	
	{		
		if (WaitForSingleObject(DServeur.Evenement,0)==WAIT_OBJECT_0)	// Si le serveur est dtermin
			send(DServeur.Destinataire,(char*)&Msg,sizeof(MessageEnvoie),NULL);	// On lui envoie le message
	}
	else		// Si on est serveur
	{
		for (i=0;i<CLIENT_MAX;i++) // Pour chaque client
		{
			if (WaitForSingleObject(DClient[i].Evenement,0)==WAIT_OBJECT_0) // S'il est connect
			{
				send(DClient[i].Destinataire,(char*)&Msg,sizeof(MessageEnvoie),NULL); // On lui envoie le message	
			}
		}
	}
	LeaveCriticalSection(&Envoyer);
}

void reseau::EnvoyerMessageA(MessageEnvoie Msg,int NDest)
{
	EnterCriticalSection(&Envoyer);
	Msg.UnVerificateur=IncrementeVerificateur();	 
	if (this->Serveur==1)
		if (WaitForSingleObject(DClient[NDest].Evenement,0)==WAIT_OBJECT_0) // S'il est connect
		{
			send(DClient[NDest].Destinataire,(char*)&Msg,sizeof(MessageEnvoie),NULL); // On lui envoie le message
		}
	LeaveCriticalSection(&Envoyer);
}


// Ajouter message bis
#if (SIMULATION_PING>0)	// Si on veut simuler un ping 

void reseau::EnvoyerMessageBis(int Mess,int ID,double* Donnees,int NDest)
{	
	EnterCriticalSection(&AjouterBis);
	int *Numero;
	SimulationMessage[SimulationConteur].Message=Mess;
	SimulationMessage[SimulationConteur].IDJoueur=ID;
	SimulationNDest[SimulationConteur]=NDest;
	if (Donnees!=NULL)
		memcpy(SimulationMessage[SimulationConteur].Donnees,Donnees,sizeof(double)*MESSAGE_PARAMETRE_MAX);
	
	Numero=new int;
	*Numero=SimulationConteur;
	CreateThread(NULL,NULL,SimulationPing,Numero,NULL,&SimulationThreadId[SimulationConteur]);
	
	SimulationConteur++;
	if ( SimulationConteur >= SIMULATION_MAX )
		SimulationConteur=0;
	LeaveCriticalSection(&AjouterBis);
}

#else	// Si on veut pas simuler de ping

void reseau::EnvoyerMessageBis(int Mess,int ID,double* Donnees,int NDest)
{
	EnterCriticalSection(&EnvoyerBis);
	MessageEnvoie Msg;
	Msg.Message=Mess;
	Msg.IDJoueur=ID;
	if (Donnees!=NULL)
		memcpy(Msg.Donnees,Donnees,sizeof(double)*MESSAGE_PARAMETRE_MAX);
	if ((NDest<0)||(NDest>=CLIENT_MAX)) // Si on peu pas envoyer au destinataire donn
	{	
		EnvoyerMessage(Msg);			// On envoie  tt le monde
	}
	else								// sinon
		EnvoyerMessageA(Msg,NDest);		// On lui envoie
	LeaveCriticalSection(&EnvoyerBis);
}

#endif

int reseau::Initialisation(bool Srvr,SOCKET Sckt,int Port)
{
	int i;	
	unsigned long ThreadId;

	InitializeCriticalSection(&Ajouter);	// On initialise les section critique	
	InitializeCriticalSection(&AjouterBis);
	InitializeCriticalSection(&Verif);
	InitializeCriticalSection(&Envoyer);
	InitializeCriticalSection(&EnvoyerBis);

	ConteurMessage=0;
	Serveur=Srvr;
	PourVerifier=0;
	SimulationConteur=0;
	PointeurReseau=this;	// Pour ne pas devoir passer tt le tps en paramtre la classe rseau

	for (i=0;i<MESSAGE_MAX;i++)
		Message[i].Evenement=CreateEvent(NULL,TRUE,FALSE,NULL);

	if (Serveur)
	{
		for (i=0;i<CLIENT_MAX;i++) // On initialise les venements
			DClient[i].Evenement=CreateEvent(NULL,TRUE,FALSE,NULL);

		// ON LANCE LA FONCTION D'ATTENTE
		PAttente.Reseau=this;
		PAttente.Port=Port;
		if (CreateThread(NULL,NULL,AttenteConnection,&PAttente,NULL,&ThreadId)!=NULL) // On lance la fonction recevoir
				CloseHandle(AttenteConnection);
	}

	if (!Serveur)
	{
		DServeur.Destinataire=Sckt;
		DServeur.Evenement=CreateEvent(NULL,TRUE,FALSE,NULL); // On initialise l'vnement
		SetEvent(DServeur.Evenement);

		PServeur.Destinataire=&DServeur; // On initialise les parametres
		PServeur.Reseau=this;
		if (CreateThread(NULL,NULL,Recevoir,&PServeur,NULL,&DServeur.ThreadId)!=NULL) // On lance la fonction recevoir
				CloseHandle(Recevoir);
	}

	return ERREUR_AUCUNE;
}











