#ifndef __EKAUQM_RESEAU__
#define __EKAUQM_RESEAU__

#include "constantes.h"
#include "includes.h"
#include "math.h"

///////////////////////////////
// Declaration de constantes //
///////////////////////////////

#define RESEAU_VERIFICATEUR_MAX	100

#define CLIENT_MAX				7

#define MESSAGE_MAX				100		// Nombre de message dans la liste
#define MESSAGE_PARAMETRE_MAX	6		// Nombre de double dans le tableu dans la struct message
#define MESSAGE_ENCORE			0				
#define MESSAGE_AUCUN			1

#define MESSAGE_ID				0		// Pour envoyer au client son id
#define MESSAGE_NOUVEAU_JOUEUR	1		// Quand un joueur se connect ou  envoyer au client pour lui dire quels sont les joueurs prsents
#define MESSAGE_PSEUDO			2		// Pour envoyer le pseudo d'un joueur  un autre
#define MESSAGE_SCORE			3		// Envoie le score d'un joueur  un autre
#define MESSAGE_DONNEE_INIT		4		// Demande l'envoie des donnes initiales
#define MESSAGE_MAP				5		// Pour envoyer le numero de la map
#define MESSAGE_COULEUR			6		// Pour envoyer la couleur
#define MESSAGE_DATE			7		// Pour verifier la date de compilation
#define MESSAGE_MAP_NOUVELLE	8		// Pour changer la map

#define MESSAGE_CAISSE			9		// Quand on rammase une caisse
#define MESSAGE_POSITION		10		// Envoie les 2 angles et la position
#define MESSAGE_DEPLACEMENT		11		// Comment on bouge 
#define MESSAGE_TIR				12		// Quand on tir...
#define MESSAGE_MORT			13		// Quand on meurt...
#define MESSAGE_EXPULSE			14		// Pour expulser un client s'il est pas sage ^^ (par contre s'il est vraiment pas sage et qu'il a modifi le jeu sa marche plus...) 
#define MESSAGE_ADIRE			15		// Pour dire qu'on veut dire
#define MESSAGE_DIRE			16		// Pour afficher ce qu'il y a a dire
#define MESSAGE_AFFICHER_SCORE	17		// Pour affichier le score
#define MESSAGE_AEXPULSE		18		// Pour dire qui il faut expulser
#define MESSAGE_TOUCHE			19		// Pour dire qu'on est touch			
															
#define MESSAGE_DECONNECTION	20		// Lors d'une deconnection 
#define MESSAGE_HOTE_DECONNECTE	21		// Quand l'hte part
#define MESSAGE_RESET			22		// Pour remetre le score  0

#define ID_SERVEUR				CLIENT_MAX		// L'id qu'on a quand on est le serveur
#define PORT_DEFAUT				2302
#define LONGUEUR_MAX			(sizeof(double)*MESSAGE_PARAMETRE_MAX)

////////////////////////////
// Structures de donnes: //
////////////////////////////

struct message		// Message inter-thread
{
	int		Numero;							// C'est le numero du message: pour les lire dans l'ordre
	int		Message;						// Le code du message
	int		IDJoueur;						// Contient le numero du joueur de l'envoyeur (sauf quand le serveur retransmet les donnes sur les client aux autres clients
	double	Donnees[MESSAGE_PARAMETRE_MAX];	// C'est les donnees du message 
	HANDLE	Evenement;						// Si desactiv on peut y stocket un message sinon c'est qu'il y a un message de stock
};

struct MessageEnvoie // Message pour transferer par le rseau
{			
	int		UnVerificateur;					// Pour vrifier si le client est envore connect
	int		Message;						// Le code du message
	int		IDJoueur;						// Contient le numero du joueur de l'envoyeur (sauf quand le serveur retransmet les donnes sur les client aux autres clients
	double	Donnees[MESSAGE_PARAMETRE_MAX];	// C'est les donnees du message 	// Si desactiv on peut y stocket un message sinon c'est qu'il y a un message de stock
};

struct destinataire
{
	unsigned long	ThreadId;		// Chaque destinataire  son thread de reception 
	SOCKET	Destinataire;			// Ca c'est le destinataire
	HANDLE	Evenement;				// Si pas activ la boucle d'attente peu le modifier sinon c'est le fonction de reception des messages
};

//////////////////////////////
// Declaration de fonctions //
//////////////////////////////

DWORD WINAPI AttenteConnection(void * Param);	// Thread d'attente des connections des clients
DWORD WINAPI Recevoir(void* Param);				// Thread pour recevoir les donnes
DWORD WINAPI SimulationPing(void* Param);		// Thread qui permet d'attendre avant d'envoyer un message

////////////////////////////
// Declaration de classes //
////////////////////////////

class reseau
{
	message Message[MESSAGE_MAX];											// Notre liste de message destin  la classe fenetre
	
public:
	bool	Serveur;														// 1 si serveur 0 si client
	int		ID;																// Son propre ID
	int		ConteurMessage;													// Pour conter les messages	
	int		PourVerifier;													// Conteur de messages
	int		SimulationConteur;												// Conteur pour la simulation du ping

	void	AjouterMessageBis(int Mess,int ID,double* Donnees);				// Pour ajouter un message sans se faire chier  remplir tt les param...
	void	AjouterMessage(MessageEnvoie  Msg);								// Pour ajouter un message dans la liste
	void	EnvoyerMessageBis(int Mess,int ID,double* Donnees,int NDest);	// Envoie un message au destinataire donn (metre -1 pour tous)
	int		ObtenirMessage(message *Msg);									// Retourne MESSAGE_ENCORE ou MESSAGE_AUCUN
	int		IncrementeVerificateur();										// Change la valeur du verificateur et retourne sa valeur 
	int		Initialisation(bool Srvr,SOCKET Sckt,int Port);					// Notre fonction pour initialiser
	void	EnvoyerMessage(MessageEnvoie  Msg);								// Envoie un message aux clients si serveur ou au serveur si client
	void	EnvoyerMessageA(MessageEnvoie Msg, int NDest);					// Envoie un message  un destinataire prcis
};

////////////////////////////
// Parametres des threads //
////////////////////////////

struct ParametreAttenteConnection
{
	int Port;			// Le port sur lequel on initialise la connection
	reseau* Reseau;		// Un pointeur sur la classe rseau dclar dans jeu
};

struct ParametreRecevoir
{
	destinataire* Destinataire;
	reseau *Reseau;	
	int id;
};

#endif
