#include "script.h"

////////////////
// Fonctions: //
////////////////

// Listeur de fichier:
int Lister(char* Nom,char* Stockage, int* NombreDeFichier)
{
	char* Texte;
	char ListeDesMap[LISTE_NOMBRE_MAX][LISTE_NOM_TAILLE_MAX];
	unsigned long NombreDeMap=0;
	unsigned long i=0,j=0,k=0;
	unsigned long Taille=0;
	unsigned long NombreLu=0;
	unsigned long TailleMax=FICHIER_TAILLE_MAX;
	
	Texte=OuvrirFichier(Nom,&Taille);
	if (Texte==NULL)
		return ERREUR_ERREUR;

	// On liste les fichier
	i=0;j=0;k=0;
	while ((i<Taille)&&(j<LISTE_NOMBRE_MAX))
	{
		while(Texte[i]!='<') // tant qu'on n'ouvre pas les <>
		{
			if (i>=Taille) 
				break;
			i++; // on avance
		}
		i++;
		while((Texte[i]!='>')&&(k<LISTE_NOM_TAILLE_MAX-1)) // tant qu'on ne ferme pas les <>
		{
			if (i>=Taille) 
				break;
			ListeDesMap[j][k]=Texte[i]; // on enregistre le caractre
			k++;
			i++;
		}
		i++;
		ListeDesMap[j][k]='\0'; 
		k=0;
		j++;
	}
	NombreDeMap=j;	

	free(Texte);

	// On copie les donnes:
	for (i=0;i<NombreDeMap;i++) 
	{
		j=-1;
		do
		{
			j++;
			Stockage[i*LISTE_NOM_TAILLE_MAX+j]=ListeDesMap[i][j];
		}while((ListeDesMap[i][j]!='\0')&&(j<LISTE_NOM_TAILLE_MAX-1));
	}
	*NombreDeFichier=NombreDeMap;

	return ERREUR_AUCUNE;
}

//Ouverture d'un fichier et copie de tout sont texte dans un tableau:
char* OuvrirFichier(char *Nom,unsigned long* Taille)
{
	HANDLE Fichier;
	char *Texte;
	unsigned long NombreLu=0;
	unsigned long TailleMax=FICHIER_TAILLE_MAX;
	
	Fichier=CreateFile(Nom,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,NULL,NULL);
	if (Fichier==INVALID_HANDLE_VALUE)
	{
		printf("Erreur lors du chargement du fichier: \"%s\"\n",Nom);
		*Taille=0;
		return NULL;
	}	
	*Taille=GetFileSize(Fichier,&TailleMax);
	Texte=new char[*Taille];
	ReadFile(Fichier,Texte,*Taille,&NombreLu,NULL);

	CloseHandle(Fichier);
	return Texte;
}

//Obtenir la prochaine balise entre
int ObtenirBalise(char* Texte,unsigned long  &ConteurActuel,unsigned long  ConteurMax)
{
	unsigned long i=ConteurActuel;
	unsigned long j=0;
	unsigned long Max=ConteurMax;
	char Balise[BALISE_TAILLE_MAX];

	while (Texte[i]!='<') // On attends qu'on ouvre un balise
	{
		i++;
		if (i>=ConteurMax)
			break;
	}
	i++;
	j=0;
	while ((Texte[i]!='>')&&(j<BALISE_TAILLE_MAX-1)) // Tend qu'on ne la ferme pas
	{
		if ((('a'>Texte[i])||(Texte[i]>'z'))&&(Texte[i]!=' ')) // pour voir s'il y a des caractre incorrects
		{
			Balise[j]='\0';
			printf("Erreur de syntaxe dans la balise \"%s\"\nCaractere incorrect:%c\n",Balise,Texte[i]);
		}

		if (i>=ConteurMax-3)
		{
			ConteurActuel=i;
			return BALISE_INCOMPLETE;
		}

		Balise[j]=Texte[i];
		j++;
		i++;
		
		if (j>BALISE_TAILLE_MAX-2) // Pour voir si la balise est trop longue
		{
			Balise[j]='\0';
			printf("Erreur de syntaxe:la balise \"%s\" est trop longue\n",j,Balise); 
		}		
	}
	Balise[j]='\0';
	ConteurActuel=i;

	if (!strcmp(Balise,"apparition"))
		return BALISE_APPARITION;

	if (!strcmp(Balise,"plafon"))
		return BALISE_PLAFON;

	if (!strcmp(Balise,"mur"))
		return BALISE_MUR;

	if (!strcmp(Balise,"porte"))
		return BALISE_PORTE;

	if (!strcmp(Balise,"caisse de soin"))
		return BALISE_CAISSE;

	if (!strcmp(Balise,"teleporteur"))
		return BALISE_TELEPORTEUR;

	if (!strcmp(Balise,"fin"))
		return BALISE_INCOMPLETE; // sinon le dernier objet n'est pas prit en conte, car avant de le prendre en conte on verifie que la balise est diffrente de BALISE_FIN

	if (i>=ConteurMax-3)
		return BALISE_INCOMPLETE;

	printf("Erreur balise \"%s\" inconnue\n",Balise);
	return BALISE_ERREUR;
}
	
//Obtenir les paramtres
int ObtenirParametre(int Type, char* Texte, unsigned long  &ConteurActuel, unsigned long  ConteurMax,unsigned int *Texture, char &C, int* Nombres)
{
	unsigned long  i=ConteurActuel;
	unsigned long  j=0;
	int Defini=0;

	while (i<ConteurMax)
	{		
		if (Texte[i]=='(')		
		{	
			if (!Defini)
			{
				if (Type==PARAMETRE_INT)
				{
					Nombres[0]=ObtenirNombre(Texte,i,ConteurMax);
				}
		
				if (Type==PARAMETRE_INT_INT)
				{
					Nombres[0]=ObtenirNombre(Texte,i,ConteurMax);
					Nombres[1]=ObtenirNombre(Texte,i,ConteurMax);
				}

				if (Type==PARAMETRE_CHAR_INT_INT_INT)
				{
					while ((Texte[i]<'a')||(Texte[i]>'z')) // on cherche le caractre
					{
						if (i>=ConteurMax-1)
							return BALISE_FIN; // tout en verifiant qu'on est pas  la fin
						i++;
					}
					C=Texte[i];
					while (Texte[i]!=',') // on cherche la porchaine virgule
					{
						if (i>=ConteurMax-1)
							return BALISE_FIN; // tout en verifiant qu'on est pas  la fin
						i++;
					}
					Nombres[0]=ObtenirNombre(Texte,i,ConteurMax);
					Nombres[1]=ObtenirNombre(Texte,i,ConteurMax);
					Nombres[2]=ObtenirNombre(Texte,i,ConteurMax);				
				}
				ConteurActuel=i;
				Defini=1;
			}
			else
			{
				return BALISE_AUCUNE; // c'est pour vrifier s'il y en a une autre aprs pour viter la duplication de la dernire
			}
		}		

		else if (Texte[i]=='<')
		{
			ConteurActuel=i;
			return ObtenirBalise(Texte,ConteurActuel,ConteurMax);
		}

		else if ((Texte[i]=='[')&&(!Defini)) // pour pas que la texture soit modifi aprs avoir definie les coord
		{
			Texture[TEXTURE_NUMERO]=ObtenirNombreTexture(Texte,i,ConteurMax);
		}

		else if ((Texte[i]=='{')&&(!Defini)) 
		{
			Texture[TEXTURE_REPETITION]=ObtenirRepetitionTexture(Texte,i,ConteurMax);
		}
		i++;
	}
	ConteurActuel=i;
	if (!Defini) // sinon sa dessine pas la derniere...
		return BALISE_FIN;
	else 
		return BALISE_AUCUNE;
}

//Obtenir le nombre:
int ObtenirNombre(char* Texte,unsigned long  &ConteurActuel,unsigned long  ConteurMax)
{
	unsigned long i=ConteurActuel;
	unsigned long j=0;
	unsigned long Max=ConteurMax;
	char Nombre[NOMBRE_TAILLE_MAX];

	i++;
	j=0;
	while ((Texte[i]!=')')&&(j<NOMBRE_TAILLE_MAX-1)&&(Texte[i]!=','))
	{
		if ((Texte[i]>='0')&&(Texte[i]<='9'))
		{
			Nombre[j]=Texte[i];
			j++;
		}
		i++;
		if (i>=ConteurMax-1)
			break;
	}
	Nombre[j]='\0';
	ConteurActuel=i;
	return atoi(Nombre);
}

//Obtenir le numero de la texture:
int ObtenirNombreTexture(char* Texte,unsigned long  &ConteurActuel,unsigned long  ConteurMax)
{
	unsigned long i=ConteurActuel;
	unsigned long j=0;
	unsigned long Max=ConteurMax;
	char Nombre[NOMBRE_TAILLE_MAX];

	i++;
	j=0;
	while ((Texte[i]!=']')&&(j<NOMBRE_TAILLE_MAX-1))
	{
		if ((Texte[i]>='0')&&(Texte[i]<='9'))
		{
			Nombre[j]=Texte[i];
			j++;
		}
		i++;
		if (i>=ConteurMax)
			break;
	}
	Nombre[j]='\0';
	ConteurActuel=i;
	return atoi(Nombre);
}

int ObtenirRepetitionTexture(char* Texte,unsigned long  &ConteurActuel,unsigned long  ConteurMax)
{
	unsigned long i=ConteurActuel;
	unsigned long j=0;
	unsigned long Max=ConteurMax;
	char Nombre[NOMBRE_TAILLE_MAX];

	i++;
	j=0;
	while ((Texte[i]!='}')&&(j<NOMBRE_TAILLE_MAX-1))
	{
		if ((Texte[i]>='0')&&(Texte[i]<='9'))
		{
			Nombre[j]=Texte[i];
			j++;
		}
		i++;
		if (i>=ConteurMax)
			break;
	}
	Nombre[j]='\0';
	ConteurActuel=i;
	return atoi(Nombre);
}