#include "texte.h"

////////////////
// Variables: //
////////////////

bool TexteInitialise=false;
int Base;  
GLuint Texture;
 
////////////////
// Fonctions: //
////////////////

// Cration de la police
void InitialiseTexte(GLuint T)
 {
    int i;
	Texture=T;
    Base=glGenLists(95);                            // On gnre 95 listes d'lments
    glBindTexture(GL_TEXTURE_2D, Texture);// On cherche la texture de notre police
    for (i=0; i<95; i++)
     {
        float cx=(float)(i%16)/16.0f;              // Position X du caractre courant
        float cy=(float)(i/16)/8.0f;               // Position Y du caractre courant

        glNewList(Base+i,GL_COMPILE);            // On commence  construire une liste
        glBegin(GL_QUADS);                          // On fait un carr
            glTexCoord2f(cx,         1.0f-cy-0.120f); glVertex2i(0,0);  // Bas gauche
            glTexCoord2f(cx+0.0625f, 1.0f-cy-0.120f); glVertex2i(16,0); // Bas Droit
            glTexCoord2f(cx+0.0625f, 1.0f-cy);        glVertex2i(16,16);// Haut Droit
            glTexCoord2f(cx,         1.0f-cy);        glVertex2i(0,16); // Haut Gauche
        glEnd();
        glTranslated(10,0,0);                       // On se dplace vers la droite
        glEndList();                                // On termine la liste
     }   // On boucle jusqu'au 256 caractre cr

	TexteInitialise=true;
 }

// Reglage de la matrice:
void ReglageAvantTexte()
{
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	glMatrixMode(GL_PROJECTION);                // On se met en PROJECTION 2D   
	glPushMatrix();								// On sauvegarde notre matrice
	glLoadIdentity();							// On reinitialise
    glOrtho(0,640,0,480,0,1);				// Fait un cran Ortho

	glMatrixMode(GL_MODELVIEW);
	
	glDisable(GL_DEPTH_TEST);
}

void ReglageApresTexte()
{
	glMatrixMode(GL_PROJECTION); 
	glPopMatrix();

	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	
	glEnable(GL_DEPTH_TEST);
}

// Affichage de texte  l'cran
void AfficheTexte(int x, int y, char *color, double size, const char *string, ...)
 {
	if (!TexteInitialise)
	{
		printf("Erreur: Affichage du texte impossible, l'initialisation n'a pas ete faite\n");
		return;
	}

    char text[TEXTE_CAR_MAX];                       // Notre texte
    va_list ap;                                     // pointeur d'une liste d'argument

    va_start(ap, string);                           // On passe la chaine en variable
        vsprintf(text, string, ap);                 // On convertit le symbole
    va_end(ap);                                     // Rsultat mis dans en texte

    glBindTexture(GL_TEXTURE_2D, Texture);			// On slectionne notre texture	
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

    ZBUFFER_ON;          
    if (color=="white") glColor3f(1.0f, 1.0f, 1.0f);
    if (color=="red") glColor3f(1.0f, 0.0f, 0.0f);
    if (color=="green") glColor3f(0.0f, 1.0f, 0.0f);
    if (color=="blue") glColor3f(0.0f, 0.0f, 1.0f);
    if (color=="yellow") glColor3f(1.0f, 1.0f, 0.0f);
    if (color=="cyan") glColor3f(0.0f, 1.0f, 1.0f);
    if (color=="purple") glColor3f(1.0f, 0.0f, 1.0f);
    glTranslated(x,y,0);                            // on translate
    glScaled(size, size, 1);                        // On modifie la taille
    glListBase(Base-32);                            // On choisit les caractres
    glCallLists(strlen(text), GL_UNSIGNED_BYTE, text); // On affiche le texte
    ZBUFFER_OFF;  
	glColor3f(1.0f, 1.0f, 1.0f);
}

bool AffichageNom(double PosX,double PosY,double Angle,double X,double Y)
{
	double x1,x2,y1,y2;
	double CosinusC;

	x1=cos(Angle*PI/180);
	y1=sin(Angle*PI/180);
	x2=X-PosX;
	y2=Y-PosY;
	
	if (x2*x2+y2*y2<DISTANCE_AFFICHAGE_NOM_C)
	{
		if ((x1*x2+y1*y2)>0)
		{
			CosinusC=(x1*x2+y1*y2)*(x1*x2+y1*y2)/ ( (x1*x1+y1*y1) * (x2*x2+y2*y2) );
			if (   (CosinusC>0.8) )// Si 0.5 < Scalaire carr/Produit des normes au carr < 0.5 
			{	
				return 1;
			}
		}
	}
	return 0;
}
////////////////////
// Classe console //
////////////////////

void console::Initialise()
{
	int i;
	TempsPasse.Reinitialise();
	for (i=0;i<CONSOLE_NOMBRE_MAX;i++)
		TextePosition[i]=CONSOLE_DESACTIVE;
	Conteur=0;
	Dire=0;
}

void console::AfficheConsole()
{
	int i;
	char *tmp;
	TempsPasse.CalculerTempsEcoule();
	for (i=0;i<CONSOLE_NOMBRE_MAX;i++)
	{
		if (TextePosition[i]!=CONSOLE_DESACTIVE)
		{
			TexteTemps[i]-=TempsPasse.msPassee;
			if (TexteTemps[i]<0)
				TextePosition[i]=CONSOLE_DESACTIVE;
			AfficheTexte(CONSOLE_X,CONSOLE_Y+TextePosition[i]*CONSOLE_ECART_VERTICAL,CONSOLE_COULEUR,CONSOLE_TAILLE,Texte[i]);			
		}
	}

	if (Dire)
	{
		tmp=new char[DirePosition+2];
		TexteDire[DirePosition]='\0';
		strcpy(tmp,TexteDire);
		tmp[DirePosition]='|';
		tmp[DirePosition+1]='\0';
		AfficheTexte(CONSOLE_DIRE_X,CONSOLE_DIRE_Y,CONSOLE_COULEUR,CONSOLE_TAILLE,tmp);
		free(tmp);
	}
}

void console::EnvoieConsole(const char* LeTexte,...)
{	   
	int i;
    va_list ap;

    va_start(ap, LeTexte);                           
        vsprintf(Texte[Conteur], LeTexte, ap);                 
    va_end(ap);  

	for (i=0;i<CONSOLE_NOMBRE_MAX;i++)
	{
		if (TextePosition[i]!=CONSOLE_DESACTIVE)
			TextePosition[i]++;
	}
	TextePosition[Conteur]=0;
	TexteTemps[Conteur]=CONSOLE_TEMPS;

	Conteur++;
	if (Conteur>=CONSOLE_NOMBRE_MAX)
		Conteur=0;
}

void console::DireCommencer()
{
	DirePosition=0;
	Dire=1;
}

void console::DireAjouterCaractere(char Caractere)
{
	if (Dire)
	{
		if (DirePosition<DIRE_TAILLE_MAX-1)
		{
			TexteDire[DirePosition]=Caractere;
			TexteDire[DirePosition+1]='\0';
			DirePosition++;
		}
	}
}

void console::DireEnleverCaractere()
{
	if (Dire)
	{
		TexteDire[DirePosition-1]='\0';
		if (DirePosition>0)
			DirePosition--;
	}
}

char* console::DireFinir()
{
	TexteDire[DirePosition]='\0';
	DirePosition++;
	char* TexteDit=new char[DirePosition];
	strcpy(TexteDit,TexteDire);
	Dire=0;
	return TexteDit;
}



	

