#include "tir.h"

///////////////
// Variables //
///////////////

int Toucheur[CLIENT_MAX+1];

////////////////
// Fonctions: //
////////////////

void tir::Initialisation()
{
	int i;
	for (i=0;i<BALLE_MAX;i++)
	{
		Balle[i].X=BALLE_DEFAUT_X;
		Balle[i].Y=BALLE_DEFAUT_Y;
		Balle[i].Z=BALLE_DEFAUT_Z;

		Balle[i].Vx=0;
		Balle[i].Vy=0;
		Balle[i].Vz=0;
	}
	Conteur=0;
}

void tir::NouvelleBalle(double x,double y,double z,double vx,double vy,double vz,int JID)
{
	Balle[Conteur].X=x;
	Balle[Conteur].Y=y;
	Balle[Conteur].Z=z;

	Balle[Conteur].Vx=vx;
	Balle[Conteur].Vy=vy;
	Balle[Conteur].Vz=vz;

	Balle[Conteur].JoueurID=JID;

	Balle[Conteur].ASupprimer=0;

	Conteur++;

	if (Conteur>=BALLE_MAX)
		Conteur=0;
}

void tir::DessineBalles()
{
	int i;
	for (i=0;i<BALLE_MAX;i++)
	{
		if BALLE_DANS_INTERVALLE
		{
				glColor3d(BALLE_R,BALLE_V,BALLE_B);
				glTranslated( Balle[i].X, Balle[i].Y, Balle[i].Z); 
				glutSolidSphere(BALLE_TAILLE*UNITE,BALLE_NB_DIV_V,BALLE_NB_DIV_H);
				glTranslated(-Balle[i].X,-Balle[i].Y,-Balle[i].Z); 
				glColor3d(1,1,1);
		}
	}
}

int* tir::CalculeColisionsEtDeplacements(double PosX,double PosY,int ms,map *Map)
{
	int i;
	double a,b,c,h,dc;
	double Vx,Vy,Vz;	

	for (i=0;i<CLIENT_MAX+1;i++)
	{
		Toucheur[i]=0;
	}
	
	for (i=0;i<BALLE_MAX;i++)
	{
		if BALLE_DANS_INTERVALLE
		{
			Vx=ms*Balle[i].Vx/1000;
			Vy=ms*Balle[i].Vy/1000;
			Vz=ms*Balle[i].Vz/1000;

			Map->CalculColisionBalle(&Balle[i],Vx,Vy,Vz);			

			a=	-Vy;
			b=	 Vx;
			c=	-a*Balle[i].X-b*Balle[i].Y;
			dc= Absolue(a*PosX+b*PosY+c)*Absolue(a*PosX+b*PosY+c)/(a*a+b*b);
			if (dc<PERSO_LARGEUR_TIR_CARRE*UNITE*UNITE)
			{
				if (SigneDe(PosX-Balle[i].X)!=SigneDe(PosX-Balle[i].X-Vx))
				{
					h=Balle[i].Z+Vz*((PosX-Balle[i].X)/Vx);
					if ((h>JOUEUR_HAUTEUR*JOUEUR_TAILLE*UNITE)&&(h<(JOUEUR_HAUTEUR+JOUEUR_HAUTEUR_MAX)*JOUEUR_TAILLE*UNITE))
					{
						if ((Balle[i].JoueurID>=0)&&(Balle[i].JoueurID<CLIENT_MAX+1))
						{
							Toucheur[Balle[i].JoueurID]++;
						}
						else
							printf("Erreur: balle anonyme (voir Tir.cpp)\n");
					}
				}
				if (SigneDe(PosY-Balle[i].Y)!=SigneDe(PosY-Balle[i].Y-Vy))
				{
					h=Balle[i].Z+Vz*((PosX-Balle[i].X)/Vx);
					if ((h>JOUEUR_HAUTEUR*JOUEUR_TAILLE*UNITE)&&(h<(JOUEUR_HAUTEUR+JOUEUR_HAUTEUR_MAX)*JOUEUR_TAILLE*UNITE))
					{
						if ((Balle[i].JoueurID>=0)&&(Balle[i].JoueurID<CLIENT_MAX+1))
						{
							Toucheur[Balle[i].JoueurID]++;
						}
						else
							printf("Erreur: balle anonyme (voir Tir.cpp)\n");
					}
				}
			}

			// Deplacement de la balle
			Balle[i].X+=Vx; //   /1000 pour la conversion en ms
			Balle[i].Y+=Vy;
			Balle[i].Z+=Vz;

			if (Balle[i].ASupprimer)
			{
				Balle[i].X=-1;
			}
		}		
	}
	return Toucheur;
}

	
	