#ifndef __EKAUQM_TIR__
#define __EKAUQM_TIR__

#include "constantes.h"
#include "includes.h"
#include "perso.h"
#include "reseau.h"
#include "balle.h"
#include "map.h"

////////////////////////////////
// Definitions de constantes: //
////////////////////////////////

#define BALLE_MAX		100
#define BALLE_TAILLE	0.1
#define BALLE_VITESSE	100  // En u/s
#define BALLE_ATTENTE	333

#define BALLE_NB_DIV_V  3 
#define BALLE_NB_DIV_H	2

#define BALLE_R			0
#define BALLE_V			0
#define BALLE_B			0

#define BALLE_X_MIN		0
#define BALLE_Y_MIN		0
#define BALLE_Z_MIN		0

#define BALLE_X_MAX		1000
#define BALLE_Y_MAX		1000
#define BALLE_Z_MAX		5

#define BALLE_DEFAUT_X	-1
#define BALLE_DEFAUT_Y	-1
#define BALLE_DEFAUT_Z	-1

#define BALLE_DANS_INTERVALLE ((BALLE_X_MIN*UNITE<Balle[i].X)&&(Balle[i].X<BALLE_X_MAX*UNITE)&&(BALLE_Y_MIN*UNITE<Balle[i].Y)&&(Balle[i].Y<BALLE_Y_MAX*UNITE)&&(BALLE_Z_MIN*UNITE<Balle[i].Z)&&(Balle[i].Z<BALLE_Z_MAX*UNITE))

//////////////////////////////
// Defininitions de classes //
//////////////////////////////

class tir
{
private:
	balle Balle[BALLE_MAX];
	int Conteur;

public:
	void Initialisation();
	void NouvelleBalle(double x,double y,double z,double vx,double vy,double vz,int JID);
	void DessineBalles();
	int* CalculeColisionsEtDeplacements(double PosX,double PosY,int ms,map *Map); // deplace toutes les balles et calcule s'il y a colison entre le joueur et la balle
};

#endif